
! This program computes the random coefficients discrete choice model of limited
! information presented in "Limited Information and Advertising in the US Personal Computer Industry"

! written by Michelle S. Goeree, 2008


program main

	implicit real*8 (a-h,o-z)
	integer, parameter :: nm=4,nds=12,nups=nds*nm,nnlk=4,nprod=2112,ns=9000,ncons=13400,nadk=9,nr=3,nqrt=12,ns_t=ns/nqrt,ncons_y=6700, &
	nmom=6*nprod+5*ncons,nnhk=4,npichar=4,nlam=4,nfi=2,nrho=2,nsmallpsi=2,ntha=2+nlam+nfi+nrho+nadk+2,		&
	netad=nsmallpsi+nnhk,nth=npichar+1+nnlk+ntha,nparm=nth+netad,nallparm=nparm+nups
	integer i,k,r,t,jt,v,j,m,ibeg,iend,jbeg,jend,sumprodt,hmflag
	real time_begin, time_end
	real*8 v_i(ns_t,nnlk),k_i(ns_t,nm),consv_i(ncons_y,nnlk,nr),consk_i(ncons_y,nm,nr)
	common/nu/v_i
	common/kappa/k_i
	common/consnu/consv_i
	common/conskappa/consk_i

	!get random draws (see datagen fortran program)
	write(6,*) 'read in nu draws'
	open(10, file='c:\michelle\pcad\programs\main\nu.txt')
	do i=1,ns_t
		read(10,100)(v_i(i,k),k=1,nnlk)
	enddo
	close(10)
100	format(3(1x,d15.7)) 

	write(6,*) 'read in kappa draws'
	open(20, file='c:\michelle\pcad\programs\main\kappa.txt')
	do i=1,ns_t
		read(20,110)(k_i(i,m),m=1,nm)
	enddo
	close(20)
110	format(4(1x,d15.7)) 

	write(6,*) 'read in simmons nu and kappa draws'
	open(30, file='c:\michelle\pcad\programs\main\consnu.txt')
	open(31, file='c:\michelle\pcad\programs\main\conskappa.txt')
	do i=1,ncons_y
		do k=1,nnlk
			read(30,115)(consv_i(i,k,r),r=1,nr)
		enddo
		do m=1,nm
			read(31,115)(consk_i(i,m,r),r=1,nr)
		enddo
	enddo
	close(30) 
	close(31)
115	format(3(1x,d15.7))  

	!call various data getting subroutines (see bottom of this program)
	call otherdata	
	call prodget
	call vendget 
	call adget
	call cpsget
	call consget 
	call ivget 

	!begin estimation process
	call cpu_time ( time_begin )
	write(6,*)'calling the estim subroutine '      
	write(320,*)'calling the estim subroutine '      
	call estim
	call cpu_time ( time_end )
	print *, 'Running time was ', (time_end - time_begin)/60, ' minutes'
	write(320,*) 'Running time was ', (time_end - time_begin)/60, ' minutes'

end program main

	subroutine estim
	!	---------------Estimation procedure ------------------
	
	use numerical_libraries
	use linear_operators
	implicit real*8 (a-h,o-z)
	external sgmmobj
	
	integer, parameter :: nprod=2112,ns=9000,ncons=13400,nk=13,nchar=6,nm=4,nds=12,nups=nds*nm,nadk=9,nqrt=12,nfirm=15,nnlk=4,nnhk=4,nw=5,	&
	nlam=4,npichar=4,nfi=2,nrho=2,ntha=2+nlam+nfi+nrho+nadk+2,nsmallpsi=2,netad=nsmallpsi+nnhk,nthmu=npichar+1+nnlk,	&
	nth=nthmu+ntha,nparm=nth+netad,nallparm=nparm+nups,ntotparm=nallparm,nmom=6*nprod+5*ncons,niv=3*nth+nparm+nups,nthl=nk+nw,ns_t=ns/nqrt,maxjt=223
	integer i,t,j,jt,c,k,kk,m,numgrad,nits,gflag,numline,lflag,hflag,numhalf,nprod_t(nqrt),cnt,est_ind(ntotparm),		&
	intflag,errflag,inchset(ns_t,maxjt,nqrt,2),covarflag,maxit,iparam(7)
	real*8 parm(nallparm),parmold(nallparm),inparm(nallparm),allparm(ntotparm),thetaad(ntha),theta(nth),upsilon(nups),thetanh(nnhk),etad(netad), &
	s_jt(nprod),sal(nprod),outshare(nprod),inshare,delta_jt(nprod),mvalold(nprod),a(niv,niv),bta(nk),eta(nw),			&
	newparm(nallparm),inphi_r(ns,2),ups(nm,13),rparam(7), xscale(nallparm)
	common/iteration/nits
	common/estimates/bta,eta    
	common/parminitial/inparm
	common/estparms/est_index
	common/evals/numgrad,gflag,numline,lflag,hflag,numhalf
	common/errflags/errflag
	common/calcint/intflag
	common/cpsintchset/inchset
	common/cpsintphir/inphi_r
	common/cov/covarflag
	common/line/dirmat
	common/objfunct/obj
	common/tobs/nprod_t					
	common/share/s_jt,sal				
	common/mval/mvalold
	common/upparm/newparm

	open(300,file='c:\michelle\pcad\programs\main\results\parmestimates.txt')
	open(310,file='c:\michelle\pcad\programs\main\results\thetalinear.txt')
	open(320,file='c:\michelle\pcad\programs\main\results\log.txt')
	open(330,file='c:\michelle\pcad\programs\main\results\directvec.txt')
	open(340,file='c:\michelle\pcad\programs\main\results\intchset.txt')
	open(360,file='c:\michelle\pcad\programs\main\results\intphir.txt')

	!set initial parameter values 
	allparm=1.						
	thetaad=1.
	etad=1.
	open(80, file='c:\michelle\pcad\programs\main\upsilon.txt')	      	      
	do m=1,nm
		read(80,180)(ups(m,i),i=1,13)	
	enddo
	close(80)
180	format(d15.7,12(1x,d15.7)) 
	ups(:,12)=-1.						
	upsilon(1:nds)=ups(2,1:nds)				
	upsilon(nds+1:nds*2)=ups(1,1:nds)		
	upsilon(2*nds+1:3*nds)=ups(3,1:nds)		
	upsilon(3*nds+1:nups)=ups(4,1:nds)		
	allparm(nthmu+1:nth)=thetaad
	allparm(nth+1:nth+nups)=upsilon
	allparm(nth+nups+1:nallparm)=etad
	
	!parms that are estimated (edit nfix variable)
	est_ind=1
	kk=0
	do k=1,ntotparm
		if (est_ind(k) .eq. 1) then
			kk=kk+1
			parm(kk)=allparm(k)
		endif
	enddo
	inparm=parm

!	initialize flags
	gflag=1				!flag for compute gradient
	numgrad=1			!# of gradient evaluations
	nits=1				!iteration number
	fract=.5			!increment for line search
	numline=0			!# of line searchs
	hflag=0				!flag for moving halfway back to old solution
	numhalf=0			!# of moves 1/2 way toward old solution
	cnt=0				!counter 
	intflag=0			!flag =1 if initial choice set
	errflag=0			!flag for too many errors 
	covarflag=1
	maxit=400
	xscale=1.0
	fscale=1.0
	iparam(1)=0

!	Set tolerance levels
	objtol=1.d-10
	deltol=1.d-10
	delssq=50.	
	s=0.
	sobjtol=1.d-1

!	Set gmm function values
	objold=1.d+10

!	Initial calculation 
	intflag=0		!=1 if first time through (so saves inchset and inphi_r)
	if (intflag .eq. 0) then
		inchset=0.
		inphi_r=0.
		outshare=0.
		jend=0
		do t=1,nqrt
			jbeg=jend+1
			inshare=0.
			do jt=1,nprod_t(t)
				j=jend+jt
				inshare=inshare+s_jt(j)
			enddo
			jend=j
			outshare(jbeg:jend)=1.-inshare
		enddo

	!	initial delta values that solve logit model
		do j=1,nprod
			delta_jt(j)=dlog(s_jt(j))-dlog(outshare(j))  
		enddo
		mvalold=dexp(delta_jt)
		intflag=1

	!	Evaluate objective function 
		call gmmobj(parm,obj) 
		objold=obj

		!reset initial calculation flag
		intflag=0
		do i=1,ns_t
			do j=1,maxjt
				do t=1,nqrt
					write(340,265)(inchset(i,j,t,v), v=1,2)
				enddo
			enddo
		enddo
		do i=1,ns
			write(360,266)(inphi_r(i,v), v=1,2)
		enddo
		265	format(1x,i9) 
		266	format(1x,d15.7) 

		!get most recent parm values
		open(350,file='c:\michelle\pcad\programs\main\results\parms.txt')	
		do k=1,nallparm
			read(350,220)parm(k)	
		enddo
		close(350)
		call gmmobj(parm,obj)
		print*,'starting objective function value',obj
		write(320,*) 'starting objective function value', obj
		objdiff=dabs(obj-objold)
		print*,'objective function value',obj
	else
		inchset=0
		inphi_r=0.
		outshare=0.
		jend=0
		do t=1,nqrt
			jbeg=jend+1
			inshare=0.
			do jt=1,nprod_t(t)
				j=jend+jt
				inshare=inshare+s_jt(j)
			enddo
			jend=j
			outshare(jbeg:jend)=1-inshare
		enddo
		do j=1,nprod
			delta_jt(j)=dlog(s_jt(j))-dlog(outshare(j))
		enddo
		mvalold=dexp(delta_jt)
		objold=1.d+10
		write(320,*) 'initial objective function evaluation'
		write(320,*) 'parm values'
		do k=1,nallparm
			write(320,220)parm(k)	
		enddo
		call gmmobj(parm,obj)
		intflag=0
		do i=1,ns_t
			do j=1,maxjt
				do t=1,nqrt
					write(340,265)(inchset(i,j,t,v), v=1,2)
				enddo
			enddo
		enddo
		do i=1,ns
			write(360,266)(inphi_r(i,v), v=1,2)
		enddo
		objdiff=dabs(obj-objold)
		print*,'initial objective function value',obj
		write(320,*) 'initial objective function value', obj
	endif
	objbest=obj
	parmold=parm

	!Optimization (the most commonly used procedures are below)

	!nelder-mead simplex search method
	call dumpol (sgmmobj,nallparm,inparm,s,sobjtol,maxit,parm,fval)

	!quasi newton method with finite difference gradient (for user supplied gradient call duming) 
	call duminf (sgmmobj,nallparm,inparm,xscale,fscale,iparam,rparam,parm,fval)

	print*,'converged'

	!write parm values
	open(350,file='c:\michelle\pcad\programs\main\results\parms.txt')
	do k=1,nallparm
		write(350,220)parm(k)	
	enddo
	close(350)
	open(96,file='c:\michelle\pcad\programs\main\results\thlinear.txt')
	do k=1,nk
		write(96,220)bta(k)	
	enddo
	do k=1,nw
		write(96,220)eta(k)	
	enddo
	close(96)

200 format(' The value of the objective function is ',1x,d25.8,/,		&
	' The number of iterations is',i11,/,						&
	' The number of gradient evaluations is ', i13,/,			&
	' The number of line searchs is ', i13,/,					&
	' The number of half-steps is ', i13)
210 format(' The value of the objective function is ',1x,d25.8,/,		&
	' The number of iterations is',i11)
220 format(1x,d15.7)
230 format(1x,f15.8)
	close(300)
	close(310)
	close(320)
	close(330)
	close(340)
	close(360)

	return
	end subroutine estim


	subroutine sgmmobj (nallparm,parm,obj)
	!	--------- used in simplex and quasi newton optimization procedures

	use numerical_libraries

	implicit real*8 (a-h,o-z)
	integer nallparm
	real*8 parm(nallparm)

	call gmmobj(parm,obj)

	return
	end subroutine sgmmobj


	subroutine gmmobj(parm,obj)
	!	---------------Compute the GMM objective function ------------------

	use numerical_libraries

	implicit real*8 (a-h,o-z)
	integer, parameter :: nprod=2112,nk=13,nw=5,nnlk=4,nm=4,nds=12,nups=nds*nm,npichar=4,nchar=6,nnhk=4,ncons=13400,nqrt=12,nfirm=15,	&
	nadk=9,nlam=4,nthl=nk+nw,nfi=2,nrho=2,ntha=2+nlam+nfi+nrho+nadk+2,nsmallpsi=2,netad=nsmallpsi+nnhk,				&
	nth=npichar+1+nnlk+ntha,nparm=nth+netad,nallparm=nparm+nups,niv=3*nth+nparm+nups,nmom=6*nprod+5*ncons
	integer i,ii,im,iq,t,f,v,k,vv,j,jj,z,numgrad,nits,gflag,numline,lflag,hflag,numhalf,zindex,errflag,covarflag
	real*8 obj,parm(nallparm),theta(nth),thetad(ntha),upsilon(nups),inva(niv,niv),adres(nprod,nm),a_jt(nprod,nm),aderr(nprod,nm),microres(ncons,nfirm), &
	z_xi(nprod,nth),z_w(nprod,nth),z_ad(nprod,nm,nparm),z_micro(ncons,nfirm,nth),weta,x(nprod,nk),w(nprod,nw),		&
	xnl(nprod,nnlk),zadm(nprod,nparm),zadtemp(nparm),zmicro(ncons,nth),zerr(niv),errz(1,niv),zm(nth),objtemp(1,1),	&
	mattemp(niv,1),invaxi(nth,nth),invaw(nth,nth),invaad(nparm,nparm),invamicro(nth,nth)
	real*8 bta(nk),eta(nw),xz(nk,nth),invbeta(nk,nk),wz(nw,nth),inveta(nw,nw),zdelta(nth),zmc(nth),xzazy(nk),wzazy(nw), &
	errtemp(2*nth),xzzy(nk),wzzy(nw),zxaxz(nk,nk),zwawz(nw,nw),aath(nth,nth),aaparm(nparm,nparm),aamicro(nth,nth),	&
	zerrmat(niv,1),errzth(1,nth),errzparm(1,nparm),errzmicro(1,nth)
	real*8, dimension(nprod) :: sims_jt,expdelta,delta_jt,xi,mc,lnmc,omega,wweta
	real*8 medresm(ncons,5),zmedm(ncons,5,nds),par,mediares(ncons,nm,5),z_media(ncons,5,nups),zmedmq(ncons,nds),zmd(nds)
	common/evals/numgrad,gflag,numline,lflag,hflag,numhalf
	common/errflags/errflag
	common/cov/covarflag
	common/estimates/bta,eta    	
	common/vars/x,xnl,w
	common/instr/z_xi,z_w
	common/adinstr/z_ad	
	common/microinstr/z_micro	
	common/mediainstr/z_media
	common/weightmat/inva
	common/weightmatparts/invaxi,invaw,invaad,invamicro
	common/edel/expdelta
	common/ads/a_jt
	common/thetalinear/xz,wz,invbeta,inveta

	theta=parm(1:nth)
	upsilon=parm(nth+1:nth+nups)

 	call mediamom(upsilon,mediares)
	call meanval(theta,delta_jt)
	expdelta=dexp(delta_jt)
	if (errflag .eq. 1) then
		obj=1.d15
		go to 50
	endif

	call mom(parm,mc,adres)
	lnmc=dlog(mc)	
	if (errflag .eq. 1) then
		obj=1.d15
		go to 50
	endif

	call micro(theta,microres)

	zdelta=matmul(transpose(z_xi),delta_jt)
	zmc=matmul(transpose(z_w),lnmc)
	xzazy=matmul(matmul(xz,invaxi),zdelta)
	wzazy=matmul(matmul(wz,invaw),zmc)
	bta=matmul(invbeta,xzazy)
	eta=matmul(inveta,wzazy)

	do j=1,nprod
		xbeta=0.
		do k=1,nk
			xbeta=xbeta+x(j,k)*bta(k)			
		enddo
		xi(j)=delta_jt(j)-xbeta
		weta=0.
		do k=1,nw
			weta=weta+w(j,k)*eta(k)			
		enddo
		omega(j)=lnmc(j)-weta
		wweta(j)=weta
	enddo

	zerr=0.
	zerr(1:nth)=matmul(transpose(z_xi),xi)
	zerr(nth+1:2*nth)=matmul(transpose(z_w),omega)
	zadm=0.
	zadtemp=0.
	do m=1,nm
		zadm=z_ad(:,m,:)
		zadtemp=zadtemp+matmul(transpose(zadm),adres(:,m))
	enddo
	zerr(2*nth+1:2*nth+nparm)=zadtemp
	zmicro=0.
	zm=0.
	do f=1,3
		zmicro=z_micro(:,f,:)	
		zm=zm+matmul(transpose(zmicro),microres(:,f))
	enddo
	do f=5,nfirm
		zmicro=z_micro(:,f,:)	
		zm=zm+matmul(transpose(zmicro),microres(:,f))
	enddo
	zerr(2*nth+nparm+1:3*nth+nparm)=zm
	medresm=0.
	zmedm=0.
	par=3*nth+nparm
	do m=1,nm
		medresm=mediares(:,m,:)
		zmedm=z_media(:,:,(m-1)*nds+1:m*nds)
		zmedmq=0.
		zmd=0.
		do iq=1,5
			zmedmq=zmedm(:,iq,:)
			zmd=zmd+matmul(transpose(zmedmq),medresm(:,iq))
		enddo
	zerr(par+(m-1)*nds+1:par+m*nds)=zmd
	enddo
	errz(1,:)=zerr
	mattemp(:,1)=matmul(inva,zerr)
	objtemp=matmul(errz,mattemp)
	obj=objtemp(1,1)

	if 	(covarflag .eq. 1) then
		open(25, file='c:\michelle\pcad\programs\main\results\omega.txt')
		open(30, file='c:\michelle\pcad\programs\main\results\xi.txt')
		open(40, file='c:\michelle\pcad\programs\main\results\adres.txt')
		open(55, file='c:\michelle\pcad\programs\main\results\microres.txt')
		open(51, file='c:\michelle\pcad\programs\main\results\mediaresnp.txt')
		open(52, file='c:\michelle\pcad\programs\main\results\mediaresmag.txt')
		open(53, file='c:\michelle\pcad\programs\main\results\mediarestv.txt')
		open(54, file='c:\michelle\pcad\programs\main\results\mediaresrad.txt')
		do j=1,nprod			
			write(25,210)omega(j)
			write(30,210)xi(j)
		enddo	
		close(25)
		close(30)
		do j=1,nprod
			write(40,220)(adres(j,m),m=1,nm)
		enddo
		close(40)
		do i=1,ncons
			write(55,230)(microres(i,v),v=1,15)
			write(51,231)(mediares(i,1,iq),iq=1,5)
			write(52,231)(mediares(i,2,iq),iq=1,5)
			write(53,231)(mediares(i,3,iq),iq=1,5)
			write(54,231)(mediares(i,4,iq),iq=1,5)
		enddo
		close(55)
		close(51)
		close(52)
		close(53)
		close(54)
		covarflag=0
	endif

110	format(56(1x,d15.7)) 
210	format(1x,d15.7) 
220	format(4(1x,d15.7)) 
230	format(15(1x,d15.7)) 
231	format(5(1x,d15.7)) 

50	continue	

	return 
	end subroutine gmmobj


	subroutine meanval(theta,delta_jt)
	!	---------------Compute mean utility -----------------------------

	use numerical_libraries
	use linear_operators

	implicit real*8 (a-h,o-z)
	integer, parameter :: nprod=2112,nk=13,nqrt=12,nm=4,nds=12,nups=nds*nm,nnlk=4,npichar=4,nchar=6,nnhk=4,nadk=9,nlam=4,nfi=2,nrho=2,	&
	ntha=2+nlam+nfi+nrho+nadk+2,nsmallpsi=2,netad=nsmallpsi+nnhk,nth=npichar+1+nnlk+ntha,nparm=nth+netad,nallparm=nparm+nups
	integer j,nummval,jbeg,jend,sumprodt,t,jt,nprod_t(nqrt),errflag
	real*8 parm(nallparm),mvaltol,deltol,mdiff,mvaldiff,theta(nth),upsilon(nups),thetaold(nth),tdiff,maxdiff
	real*8, dimension(nprod) :: expdelta,delta_jt,s_jt,p_jt,sims_jt,sal,mvalold
	common/share/s_jt,sal
	common/price/p_jt
	common/mval/mvalold
	common/oldparm/thetaold			
	common/tobs/nprod_t	
	common/simshare/sims_jt
	common/errflags/errflag

	!near solution inversion is more accurate
	do k=2,nth
		maxdiff=dabs(theta(1)-thetaold(1))
		tdiff=dabs(theta(k)-thetaold(k))
		if (tdiff .ge. maxdiff) then
			maxdiff=tdiff
		endif
	enddo
	if (maxdiff .le. 0.01) then
		mvaltol=1.d-9
	else
		mvaltol=1.d-6
	endif

	thetaold=theta
	nummval=0
	edelta=0.
	mvaltol=1.d-10	
	expdelta=mvalold

	jend=0
	do t=1,nqrt
		sumprodt=0
		if (t .ge. 2) then
			do jt=1,t-1
				sumprodt=sumprodt+nprod_t(jt)
			enddo
		endif
		jbeg=sumprodt+1
		jend=sumprodt+nprod_t(t)
		mvaldiff=1.				
		do while (mvaldiff .gt. mvaltol)
			call mktsh(theta,t,expdelta,sims_jt)				
			if (errflag .eq. 1) then
				go to 70
			endif
			mvaldiff=0.		
			do j=jbeg,jend
				expdelta(j)=mvalold(j)*s_jt(j)/sims_jt(j)
				mdiff=expdelta(j)-mvalold(j)
				mvaldiff=mvaldiff+mdiff*mdiff
				mvalold(j)= expdelta(j)
			enddo
			nummval=nummval+1			
		enddo
	enddo

	!open(360,file='c:\michelle\pcad\programs\main\finalresults\initialdelta.txt')
	!do j=1,nprod
	!	write(360,270)delta_jt(j)
	!enddo
	!close(360)
	!270 format(1x,d15.7)

	delta_jt=dlog(expdelta)
		
70	continue

	return
	end subroutine meanval		


	subroutine mktsh(theta,t,expdelta,sims_jt)		

	!	--------------- Simulate market share for each product -----------------------

	use numerical_libraries
	use linear_operators

	implicit real*8 (a-h, o-z)
	integer, parameter :: nprod=2112,nk=13,nqrt=12,nm=4,nds=12,nups=nds*nm,nnlk=4,npichar=4,nchar=6,maxjt=223,nw=5,nv=2,nadk=9,ns=9000,	&
	nven=15,ns_t=ns/nqrt,nnhk=4,nlam=4,nfi=2,nrho=2,ntha=2+nlam+nfi+nrho+nadk+2,nsmallpsi=2,netad=nsmallpsi+nnhk,			&
	nthmu=npichar+1+nnlk,nth=nthmu+ntha,nparm=nth+netad,nallparm=nparm+nups
	integer i,ii,ibeg,iend,m,v,j,jj,rr,k,t,jt,r,rt,chset(nprod),inchset(ns_t,maxjt,nqrt,nv),jbeg,jend,nits,nprod_t(nqrt), &
	sumprodt,ven(nprod),np,intflag,errflag,iseedi,iseed(nqrt)
	real*8 theta(nth),upsilon(nups),etad(netad),alpha,thetaad(ntha),smallpi,gam,thetamu(nthmu),ad_jt(nprod,nm),inc(ns),				&
	admom_ij(maxjt,nm),phi_r,dtau_ad(nprod,nm),da_jm(maxjt,maxjt,nm,nqrt),da_ijm(maxjt,maxjt,nm),inphi_r(ns,nv),		&
	da_ijmr(maxjt,maxjt,nm),outprob,outshare,sharesum,inad_jt(nprod,nm),dtaujm,k_i(ns_t,nm),phi_rstar,sij,phatij,	&
	cons,scaler,ds_ijr(maxjt,maxjt),ds_ijt(maxjt,maxjt),u_jt(maxjt),ds_jt(maxjt,maxjt,nqrt),demups(ns,nm)
	real*8, dimension(nprod) :: expdelta,expprob,s_ij,phat_ij,sims_jt,p_jt
	real*8, dimension(ns_t,maxjt) :: phi_ijt,mu_ijt,aamu_ijt,aaphi_ijt
	common/errflags/errflag
	common/income/inc
	common/tobs/nprod_t
	common/vendor/ven
	common/adexp/ad_jt		
	common/dtauad/dtau_ad			
	common/antimu/aamu_ijt
	common/antiphi/aaphi_ijt
	common/price/p_jt		
	common/pfoc/ds_jt
	common/afoc/da_jm		
	common/demoups/demups					
	common/cpsintchset/inchset
	common/cpsintphir/inphi_r
	common/calcint/intflag
	common/kappa/k_i

	gam=theta(nthmu+1)					
	smallpi=theta(nthmu+2)	
	thetamu=theta(1:nthmu)		
	thetaad=theta(nthmu+1:nth) 	
	alpha=theta(1)
	if (t .le. 4) then
		scaler=99.627
	elseif (t .le. 8) then
		scaler=101.018
	else
		scaler=102.528
	endif

	call calcad(gam,smallpi,t,ad_jt)			
	call mufunc(thetamu,t,mu_ijt)							
	call ind_phi(thetaad,t,phi_ijt)			
	sumprodt=0
	if (t .ge. 2) then
		do jt=1,t-1
			sumprodt=sumprodt+nprod_t(jt)
		enddo
	endif
	jbeg=sumprodt+1
	jend=sumprodt+nprod_t(t)
	np=nprod_t(t)

	errflag=0
	sims_jt(jbeg:jend)=0.
	ds_ijt=0.
	ds_jt(:,:,t)=0.
	da_ijm=0.
	da_jm(:,:,:,t)=0.
	chprob=0.
	outshare=0.

	ibeg=(t-1)*ns_t+1
	iend=t*ns_t
	!generates (non-changing) random uniforms for each i
	iseed=[123457,933720135,76204876,30276185,	&
			29875930,8410092,5938700,7433549,	&
			7209500,4528776,3872057,1102398]
	iseedi=iseed(t)
	u_jt=0.
	call rnset(iseedi)
	call drnun(np,u_jt(1:np))
	call rnget(iseedi)

	varloop: do v=1,2			!antithetic acceleration
		if (v .eq. 2) then
			u_jt=1-u_jt				
			mu_ijt=aamu_ijt		
			phi_ijt=aaphi_ijt	
			k_i=1./k_i
		endif
		ii=0
		iloop: do i=ibeg,iend
			ii=ii+1
			if (intflag .eq. 1) then
				chset(jbeg:jend)=0	
				where (phi_ijt(ii,1:np) .ge. u_jt(1:np)) chset(jbeg:jend)=1
				phi_r=1.
				jj=0
				do j=jbeg,jend
				jj=jj+1
					if (chset(j) .eq. 1) then			
						phi_r=phi_r*phi_ijt(ii,jj)
					else
						phi_r=phi_r*(1-phi_ijt(ii,jj))
					endif
				enddo
				inchset(ii,1:np,t,v)=chset(jbeg:jend)
				inphi_r(i,v)=phi_r
			else
				chset(jbeg:jend)=inchset(ii,1:np,t,v)
				phi_r=1.
				jj=0
				do j=jbeg,jend
					jj=jj+1
					if (chset(j) .eq. 1) then
						phi_r=phi_r*phi_ijt(ii,jj)
					else
						phi_r=phi_r*(1-phi_ijt(ii,jj))
					endif
				enddo
			endif
			sumprob=0.
			expprob(jbeg:jend)=0.
			jj=0
			do j=jbeg,jend
				jj=jj+1
				expprob(j)=expdelta(j)*dexp(mu_ijt(ii,jj))
				if (chset(j) .eq. 1) then 
					sumprob=sumprob+expprob(j)
				endif
			enddo
			sumprob=sumprob+inc(i)**alpha
			s_ij(jbeg:jend)=0.
			phat_ij(jbeg:jend)=0.
			chprob=0.
			jloop: do j=jbeg,jend
				if (chset(j) .eq. 1) then
					chprob=expprob(j)/sumprob
					s_ij(j)=phi_r*chprob/inphi_r(i,v)				
					phat_ij(j)=chprob
				endif
			enddo jloop			

			jt=0
			ds_ijr=0.
			da_ijmr=0.
			jj=0
			do j=jbeg,jend	
				jj=jj+1
				jt=jt+1
				phij=phi_ijt(ii,jj)
				phi_rstar=phi_r/inphi_r(i,v)
				sij=s_ij(j)
				phatij=phat_ij(j)
				cons=scaler*alpha/(inc(i)-p_jt(j))
				if (chset(j) .eq. 1) then
					rt=0
					rrloop: do rr=jbeg,jend
						rt=rt+1
						if (ven(j) .eq. ven(rr)) then
							if (inc(i) .ge. p_jt(j)) then
								if (j .eq. rr) then
									ds_ijr(jt,rt)=-cons*sij*(1-phatij)
								else
									ds_ijr(jt,rt)=cons*s_ij(rr)*phat_ij(rr)
								endif		
							endif
							do m=1,nm
								dtaujm=dtau_ad(j,m)+k_i(ii,m)+demups(i,m)
								if (chset (rr) .eq. 1) then														
									da_ijmr(jt,rt,m)=phi_rstar*(1-phij)*dtaujm*phat_ij(rr)	
								else 
									da_ijmr(jt,rt,m)=phi_rstar*(-phij)*dtaujm*phat_ij(rr)		
								endif   
							enddo
						endif
					enddo rrloop
				endif
			enddo
			outprob=(inc(i)**alpha)/sumprob
			outshare=outshare+phi_r*outprob/inphi_r(i,v)
			da_ijm=da_ijm+da_ijmr
			ds_ijt=ds_ijt+ds_ijr
 			sims_jt(jbeg:jend)=sims_jt(jbeg:jend)+s_ij(jbeg:jend)
		enddo iloop
	enddo varloop	

	!after antithetic acceleration change back
	k_i=1./k_i	

	sims_jt(jbeg:jend)=sims_jt(jbeg:jend)/real((2*ns_t))

	!check that shares sum to one
	!outshare=outshare/real((2*ns_t))
	!sharesum=0.
	!do j=jbeg,jend
	!	sharesum=sharesum+sims_jt(j)
	!enddo
	!if (sharesum .ge. 1.1d0) then
	!	write(320,*) 'inside sum of shares', sharesum, 'qrt', t
	!endif	
	!sharesum=sharesum+outshare
	!if ((sharesum .ge. 1.1d0) .or. (sharesum .le. .95d0)) then
	!	write(320,*)'outside share', outshare  , 'sum of shares', sharesum, 'qrt', t
	!endif
	!outshare=0.

	da_jm(1:np,1:np,1:nm,t)=da_ijm/real((2*ns_t))
	ds_jt(1:np,1:np,t)=-ds_ijt/real((2*ns_t))
			
	return
	end subroutine mktsh			


	subroutine mom(parm,mc,adres)
	!	---------- For macro moments: firms FOCs --------------------

	use numerical_libraries
	use linear_operators

	implicit real*8 (a-h,o-z)
	integer, parameter :: nprod=2112,nk=13,nqrt=12,nm=4,nds=12,nups=nds*nm,nnlk=4,npichar=4,nchar=6,maxjt=223,nw=5,nlam=4,nnhk=4,nadk=9, &
	nfi=2,nrho=2,ntha=2+nlam+nfi+nrho+nadk+2,nsmallpsi=2,netad=nsmallpsi+nnhk,nfirm=15,nth=npichar+1+nnlk+ntha,		&
	nparm=nth+netad,nallparm=nparm+nups
	integer t,j,m,jt,rt,r,f,jbeg,jend,sumprodt,np,cnt,ven(nprod),nprod_t(nqrt),nits,numgrad,gflag,numline,lflag,hflag, &
	numhalf,hhs(29),lowmark,highmark,lowhflag,errflag,penflag
	real*8 parm(nallparm),theta(nth),upsilon(nups),etad(netad),smallpsi(nsmallpsi),thetanh(nnhk),invd,xad(nprod,3),ds_jt(maxjt,maxjt,nqrt),		&
	adp_t(nqrt,nm),a_jt(nprod,nm),adres(nprod,nm),mrnh,admom_jt(maxjt,nm),da_jm(maxjt,maxjt,nm,nqrt),admarkup,h_jm, &
	invds_jt(maxjt,maxjt),ds_j(maxjt,maxjt),msize,pi,sqrtpi
	real*8, dimension(nprod) :: p_jt,mc,mup,pnh_jt,mr_jt,sims_jt,markup,saloth
	common/vendor/ven					
	common/tobs/nprod_t					
	common/evals/numgrad,gflag,numline,lflag,hflag,numhalf
	common/errflags/errflag
	common/adchar/xad					
	common/adprices/adp_t				
	common/nonhome/pnh_jt		
	common/allsales/saloth
	common/numhhs/hhs
	common/price/p_jt		
	common/ads/a_jt
	common/simshare/sims_jt
	common/pfoc/ds_jt
	common/afoc/da_jm				

	etad=parm(nth+nups+1:nallparm)
	smallpsi=etad(1:nsmallpsi)
	thetanh=etad(nsmallpsi+1:netad)
	sigad=1
	pi=acos(-1.)
	sqrtpi=sqrt(1/(2*pi))

	open(10, file='c:\michelle\pcad\programs\main\results\markuplow.txt')
	open(15, file='c:\michelle\pcad\programs\main\results\markuphigh.txt')
	open(20, file='c:\michelle\pcad\programs\main\results\hnegative.txt')
	lowmark=0
	highmark=0
	lowhflag=0
	errflag=0
	penflag=40	

	do t=1,nqrt
		msize=real(hhs(4+t))		
		sumprodt=0
		if (t .ge. 2) then
			do jt=1,t-1
				sumprodt=sumprodt+nprod_t(jt)
			enddo
		endif
		jbeg=sumprodt+1
		jend=sumprodt+nprod_t(t)
		np=nprod_t(t)

		ds_j=0.
		invds_jt=0.
		ds_j(1:np,1:np)=ds_jt(1:np,1:np,t)
		call dlinrg(np,ds_j(1:np,1:np),np,invds_jt(1:np,1:np),np)
		markup(jbeg:jend)=matmul(invds_jt(1:np,1:np),sims_jt(jbeg:jend))	
		mc(jbeg:jend)=p_jt(jbeg:jend)-markup(jbeg:jend)	
		do j=jbeg,jend
			if (markup(j) .le. 0.d0) then
				mc(j)=p_jt(j)
				write(10,*)j
				lowmark=lowmark+1
			endif
			if (mc(j) .le. 0.d0) then	
				mc(j)=1.d-6
				write(15,*)j
				highmark=highmark+1	
			endif
		enddo

		jt=0
		do j=jbeg,jend
			jt=jt+1			
			mrnh=thetanh(1)+thetanh(2)*pnh_jt(j)+thetanh(3)*xad(j,3)+thetanh(4)*saloth(j)
			do m=1,nm
				ajt=a_jt(j,m)
				admarkup=0.
				rt=0
				do r=jbeg,jend				
					rt=rt+1
					if (ven(j) .eq. ven(r)) then
						admarkup=admarkup+(p_jt(r)-mc(r))*da_jm(jt,rt,m,t)
					endif
				enddo
				h=msize*admarkup+mrnh
				if (h .le. 0.d0) then
					if (ajt .ne. 0.d0) then
						lowhflag=lowhflag+1
					endif
					h_jm=(-20.d0)-smallpsi(1)-smallpsi(2)*adp_t(t,m)
				else
					h_jm=dlog(h)-smallpsi(1)-smallpsi(2)*adp_t(t,m)
				endif
				if (ajt .eq. 0.) then
					cdfh=dnordf(h_jm)
					if (cdfh .eq. 1.d0)  then				
						cdfh=.99999d0
					endif
					exph=(-.5d0)*h_jm*h_jm					
					pdfh=sqrtpi*dexp(exph)
					adres(j,m)=	-pdfh/(1-cdfh)
				else
					adres(j,m)=h_jm
				endif
			enddo
		enddo
	enddo		
	close(10)
	close(15)
	close(20)

	if (lowmark .ge. penflag) then
		errflag=1
	elseif (highmark .ge. penflag) then
		errflag=1
	elseif (lowhflag .ge. penflag*20) then
		errflag=1
	endif

	return
	end subroutine mom

	subroutine micro(theta,microres)
	!	------------- For micro moment conditions -------------------

	use numerical_libraries
	use linear_operators

	implicit real*8 (a-h,o-z)
	integer, parameter :: nobi=20100,ncons=13400,nnlk=4,npichar=4,nchar=6,nprod=2112,nk=13,nw=5,nm=4,nds=12,nups=nds*nm,nadk=9,nr=3,nv=2, &
	ncons_qrt=8,nfirm=15,nqrt=12,maxjt=223,ncons_y=6700,nlam=4,nthmu=npichar+1+nnlk,nfi=2,nrho=2,						&
	ntha=2+nlam+nfi+nrho+nadk+2,nnhk=4,nsmallpsi=2,netad=nsmallpsi+nnhk,nsimprod=2029,jend_y1=1030,					&
	nth=npichar+1+nnlk+ntha,nparm=nth+netad,nallparm=nparm+nups,allprd=2869
	integer i,ii,j,k,m,jt,rt,rr,r,vt,t,v,va,y,d,f,jbeg,jend,ibeg,iend,tbeg,tend,nits,sumprodt,ven(nprod),sumprodv,		&
	nprod_t(nqrt),venpurch(ncons),pcnew(ncons),chset(nsimprod),sumj,intflag,iseedsim,np,age(nprod)
	real*8 theta(nth),upsilon(nups),alpha,lam(nlam),inlam(nlam),pi(npichar),sigv(nnlk),fi(nfi),rho(nrho),bigpsi(nadk),inparm(nallparm), &
	etau_j,phi_r,inphi_r,consdemups(ncons,nm),inc(ncons),cchar_i(ncons,nchar),ad_jt(nprod,nm),ajm,adp_t(nqrt,nm),		&
	s_ift(nfirm),microres(ncons,nfirm),mu_ijt,tauj,intau_j,consv_i(ncons_y,nnlk,nr),consk_i(ncons_y,nm,nr),			&
	a_jm(nprod,nm),lyp,insumv,ina_jm(nprod,nm),phitemp,inphitemp,expdelta(nprod),p_jt(nprod),x(nprod,nk),xad(nprod,3), &
	xnl(nprod,nnlk),cchar_ad(ncons,13),s_firm(nfirm,2),u_jt(jend_y1),w(nprod,nw),gamad,nuad
	real*8, dimension(nsimprod) :: s_ijt,mubar,taubar,phi_ijt,expprob,intaubar,inphi,s_jr,taubartemp,intaubartemp
	common/iteration/nits
	common/vendor/ven					
	common/tobs/nprod_t					
	common/edel/expdelta
	common/vars/x,xnl,w
	common/adchar/xad					
	common/price/p_jt		
	common/pcage/age
	common/adprices/adp_t							
	common/adexp/ad_jt
	common/conchar/cchar_ad				
	common/simdemean/cchar_i
	common/siminc/inc				
	common/simpurch/venpurch,pcnew	
	common/simdemoups/consdemups
	common/consnu/consv_i
	common/conskappa/consk_i
	common/tauinitial/intaubartemp
	common/parminitial/inparm	
	common/adinitial/ina_jm
	common/calcint/intflag

	alpha=theta(1)
	pi=theta(2:npichar+1)
	sigv=theta(npichar+2:nthmu)
	lam=theta(nthmu+3:nthmu+nlam+2)
	fi=theta(nthmu+nlam+3:nthmu+nlam+nfi+2)
	rho=theta(nthmu+nlam+nfi+3:nth-nadk-2)
	bigpsi=theta(nth-nadk-1:nth-2)	
	gamad=theta(nth-1)
	nuad=theta(nth)
	inlam=inparm(nthmu+3:nthmu+nlam+2)	
	microres=0.

	do t=1,ncons_qrt
		sumprodt=0
		if (t .ge. 2) then
			do jt=1,t-1
				sumprodt=sumprodt+nprod_t(jt)
			enddo
		endif
		jbeg=sumprodt+1
		jend=sumprodt+nprod_t(t)
		taubartemp(jbeg:jend)=0.
		do j=jbeg,jend
			tauj=0.0
			do m=1,nm
				ajt=ad_jt(j,m)
				a_jm(j,m)=ajt
				if (m .le. 2) then
					tauj=tauj+ajt*(fi(1)+rho(1)*ajt)
				elseif (m .eq. 3) then
					tauj=tauj+ajt*(fi(2)+rho(2)*ajt)
				endif
			enddo
			f=xad(j,1)
			if (f .ge. 1) then
				taubartemp(j)=tauj+xad(j,2)*bigpsi(f)+gamad*age(j)
			else
				taubartemp(j)=tauj+gamad*age(j)
			endif
		enddo
	enddo
	if (intflag .eq. 1) then
		intaubartemp=taubartemp
		ina_jm=a_jm
	endif
	yloop: do y=1,2
		if (y .eq. 1) then
			ibeg=1
			iend=ncons_y
			tbeg=1
			tend=4			
			jbeg=1
			jend=jend_y1
		else
			ibeg=ncons_y+1
			iend=ncons
			tbeg=5
			tend=8
			jbeg=jend_y1+1
			jend=nsimprod
		endif
		ii=0
		iloop: do i=ibeg,iend
			ii=ii+1
			s_ijt(jbeg:jend)=0.
			chprob=0.					
			prodloop: do j=jbeg,jend
				yp=inc(i)-p_jt(j)
				if (yp .le. 0.d0) then
					mubar(j)=-700.d0
				else
					lyp=dlog(yp)
					sumk=pi(1)*xnl(j,2)*cchar_i(i,2)+pi(2)*xnl(j,3)*cchar_i(i,4)+xnl(j,4)*(pi(3)*cchar_i(i,1)+pi(4)*cchar_i(i,5))
					mubar(j)=alpha*lyp+sumk
				endif
				tauj=0.0
				do m=1,nm
					tauj=tauj+consdemups(i,m)*a_jm(j,m)
				enddo
				taubar(j)=nuad*tauj+taubartemp(j)+lam(1)+lam(2)*cchar_ad(i,5)+lam(3)*cchar_ad(i,6)+lam(4)*cchar_ad(i,13)
				if (nits .eq. 1) then
					tauj=0.0
					do m=1,nm
						tauj=tauj+consdemups(i,m)*ina_jm(j,m)
					enddo
					intaubar(j)=nuad*tauj+intaubartemp(j)+inlam(1)+inlam(2)*cchar_ad(i,5)+inlam(3)*cchar_ad(i,6)+inlam(4)*cchar_ad(i,13)	 	
				endif
			enddo prodloop

			varloop: do va=1,2
				!antithetic acceleration
  				if (va .eq. 2) then			
					consv_i=-consv_i		
					consk_i=1./consk_i		
				endif			
				rloop: do r=1,nr   
					if (r .eq. 1) then
						if (ibeg .eq. 1) then
							iseedsim=223457
						else
							iseedsim=5676294
						endif
					endif
					sumj=jend-jbeg+1
					u_jt=0.					
					call rnset(iseedsim)
					call drnun(sumj,u_jt(1:sumj))
					call rnget(iseedsim)
  					if (va .eq. 2) then			
						u_jt=1-u_jt
					endif			
					phi_ijt(jbeg:jend)=0.
					inphi(jbeg:jend)=0.
					do j=jbeg,jend						
						sumv=0.
						insumv=0.
						do m=1,nm
							sumv=sumv+a_jm(j,m)*consk_i(ii,m,r)
							insumv=insumv+ina_jm(j,m)*consk_i(ii,m,r)
						enddo
						tau_j=taubar(j)+sumv
						intau_j=intaubar(j)+insumv	 	
						if (tau_j .ge. 10.d0) then
							phi_ijt(j)=.99999d0
						else
							etau_j=dexp(tau_j)
							phitemp=etau_j/(1+etau_j)
							if (phitemp .eq. 1.d0) then
								phitemp=.99999d0
							endif
							phi_ijt(j)=phitemp
						endif
						if (intau_j .ge. 10.d0) then
							inphi(j)=.99999d0
						else
							etau_j=dexp(intau_j)
							inphitemp=etau_j/(1+etau_j)
							if (inphitemp .eq. 1.d0) then
								inphitemp=.99999d0
							endif
							inphi(j)=inphitemp
						endif
					enddo
					chset(jbeg:jend)=0	
					where (inphi(jbeg:jend) .ge. u_jt(1:sumj)) chset(jbeg:jend)=1
					phi_r=1.
					do j=jbeg,jend						
						if (chset(j) .eq. 1) then
							phi_r=phi_r*phi_ijt(j)
						else
							phi_r=phi_r*(1-phi_ijt(j))
						endif
					enddo
					inphi_r=1.
					do j=jbeg,jend						
						if (chset(j) .eq. 1) then
							inphi_r=inphi_r*inphi(j)
						else
							inphi_r=inphi_r*(1-inphi(j))
						endif
					enddo
					sumprob=0.
					expprob(jbeg:jend)=0.
					do j=jbeg,jend
						sumv=0.
						do k=1,nnlk
							sumv=sumv+xnl(j,k)*sigv(k)*consv_i(ii,k,r)
						enddo
						mu_ijt=mubar(j)+sumv
						if (mu_ijt .gt. 700d0) then
							mu_ijt=700d0
						elseif (mu_ijt .lt. -700d0) then
							mu_ijt=-700d0
						endif 
						expprob(j)=expdelta(j)*dexp(mu_ijt)
						if (chset(j) .eq. 1) then 
							sumprob=sumprob+expprob(j)
						endif
					enddo
					sumprob=inc(i)**alpha+sumprob
					s_jr(jbeg:jend)=0.
					do j=jbeg,jend
						if (chset(j) .eq. 1) then
							chprob=expprob(j)/sumprob
							s_jr(j)=phi_r*chprob/inphi_r													
						endif
					enddo 			
					s_ijt(jbeg:jend)=s_ijt(jbeg:jend)+s_jr(jbeg:jend)
				enddo rloop
			enddo varloop

			!after antithetic acceleration change back
			consv_i=-consv_i		
			consk_i=1./consk_i		

			s_ift=0.
			do j=jbeg,jend
				v=ven(j)
				if (v .eq. 15) then
					v=14
				elseif (v .eq. 17) then
					v=15
				endif
				s_ift(v)=s_ift(v)+s_ijt(j)				
			enddo
			do v=1,3
				microres(i,v)=-s_ift(v)
			enddo
			do v=5,nfirm
				microres(i,v)=-s_ift(v)
			enddo
			v=venpurch(i)
			if ((v .gt. 0) .and. (v .le. 15)) then
				microres(i,v)=1.d0-s_ift(v)
			endif
		enddo iloop
	enddo yloop

	return
	end subroutine micro

	
	subroutine mediamom(upsilon,mediares)
	!	---- For media exposure moment conditions -------------

	use numerical_libraries
	use linear_operators

	implicit real*8 (a-h,o-z)
	integer, parameter :: nm=4,nds=12,ns=9000,ncons=13400,nups=nm*nds
	integer ii,i,m,him(ncons,nm),hm
	real*8 thresh(4,nm),threshm(4),upsilon(nups),ups(nm,nds),d_ad(ns,14),cchar_ad(ncons,13),demups(ns,nm),consdemups(ncons,nm), &
	ddsum,dsum1,dsum2,dsum3,dsum4,F1,F2,F3,F4,mediares_i(nm,5),mediares(ncons,nm,5)
	common/mediac/thresh					
	common/mediax/him						
	common/cps/d_ad	
	common/conchar/cchar_ad				    
	common/demoups/demups						
	common/simdemoups/consdemups

	ups(1,:)=upsilon(1:nds)
	ups(2,:)=upsilon(nds+1:nds*2)
	ups(3,:)=upsilon(2*nds+1:3*nds)
	ups(4,:)=upsilon(3*nds+1:nups)
	demups=matmul(d_ad(:,1:12),transpose(ups))
	consdemups=matmul(cchar_ad(:,1:12),transpose(ups))

	mediares=0.
	iloop: do i=1,ncons
		mloop: do m=1,nm
			threshm=thresh(:,m)
			ddsum=consdemups(i,m)
			dsum1=threshm(1)-ddsum
			dsum2=threshm(2)-ddsum
			dsum3=threshm(3)-ddsum
			dsum4=threshm(4)-ddsum
			F1=dnordf(dsum1)
			F2=dnordf(dsum2)
			F3=dnordf(dsum3)
			F4=dnordf(dsum4)
			mediares_i(m,1)=-1+F1
			mediares_i(m,2)=-F1+F2
			mediares_i(m,3)=-F2+F3
			mediares_i(m,4)=-F3+F4
			mediares_i(m,5)=-F4
			hm=him(i,m)		
			mediares_i(m,hm)=1.+mediares_i(m,hm)
		enddo mloop
		mediares(i,1,:)=mediares_i(1,:)
		mediares(i,2,:)=mediares_i(2,:)
		mediares(i,3,:)=mediares_i(3,:)
		mediares(i,4,:)=mediares_i(4,:)
	enddo iloop

	end subroutine mediamom

	subroutine mufunc(thetamu,t,mu_ijt)
	!	------------ Compute non-linear part of utility (mu_ijt) -------------

	use numerical_libraries  
	use linear_operators

	implicit real*8 (a-h, o-z)
	integer, parameter :: ns=9000,nnlk=4,npichar=4,nchar=6,nprod=2112,nk=13,nqrt=12,nadk=9,ns_t=ns/nqrt,maxjt=223,nm=4,nds=12,nups=nds*nm, &
	nthmu=npichar+1+nnlk,nw=5
	integer i,ii,jj,ibeg,iend,j,k,jt,t,d,jbeg,jend,nprod_t(nqrt),sumprodt
	real*8 thetamu(nthmu),alpha,pi(npichar),sigv(nnlk),mu_ijt(ns_t,maxjt),inc(ns),lyp,p_jt(nprod),aamu_ijt(ns_t,maxjt), &
	msumk,v_i(ns_t,nnlk),mu,aamu,xnl(nprod,nnlk),x(nprod,nk),w(nprod,nw)
	common/vars/x,xnl,w
	common/price/p_jt			
	common/cpsdemean/d_i(ns,nchar)		
	common/income/inc	
	common/tobs/nprod_t	
	common/antimu/aamu_ijt
	common/nu/v_i

	alpha=thetamu(1)
	pi=thetamu(2:npichar+1)
	sigv=thetamu(npichar+2:nthmu)
	sumprodt=0
	if (t .ge. 2) then
		do jt=1,t-1
			sumprodt=sumprodt+nprod_t(jt)
		enddo
	endif
	jbeg=sumprodt+1
	jend=sumprodt+nprod_t(t)
	ibeg=(t-1)*ns_t+1
	iend=t*ns_t

	mu_ijt=0.
	aamu_ijt=0.
	ii=0
	do i=ibeg,iend
		ii=ii+1
		yp=0.
		jj=0
		do j=jbeg,jend
			jj=jj+1
			yp=inc(i)-p_jt(j)
			if (yp .le. 0.d0) then
				mu_ijt(ii,jj)=-700.d0
				aamu_ijt(ii,jj)=-700.d0
				go to 150
			endif	
			lyp=dlog(yp)
			sumk=0.0
			msumk=0.
			do k=1,nnlk			
				sumk=sumk+xnl(j,k)*sigv(k)*v_i(ii,k)
				!antithetic acceleration
				msumk=msumk-xnl(j,k)*sigv(k)*v_i(ii,k)
			enddo
			sumd=pi(1)*xnl(j,2)*d_i(i,2)+pi(2)*xnl(j,3)*d_i(i,4)+pi(3)*xnl(j,4)*d_i(i,1)+pi(4)*xnl(j,4)*d_i(i,5)
			mu=alpha*lyp+sumk+sumd
			!antithetic acceleration
			aamu=alpha*lyp+msumk+sumd
			if (mu .gt. 700d0) then
				mu_ijt(ii,jj)=700d0
			elseif (mu .lt. -700d0) then
				mu_ijt(ii,jj)=-700d0
			else
				mu_ijt(ii,jj)=mu
			endif
			if (aamu .gt. 700d0) then
				aamu_ijt(ii,jj)=700d0
			elseif (aamu .lt. -700d0) then
				aamu_ijt(ii,jj)=-700d0
			else
				aamu_ijt(ii,jj)=mu
			endif
150			continue
		enddo
	enddo

	return
	end subroutine mufunc

	subroutine ind_phi(thetaad,t,phi_ijt)
	!	---------------Computes the "individual" phi probabilities ------------------

	use numerical_libraries
	use linear_operators

	implicit real*8 (a-h,o-z)
	integer,parameter :: npichar=4,nchar=6,ns=9000,nm=4,nds=12,nups=nds*nm,nprod=2112,nnlk=4,nk=13,nqrt=12,nadk=9,nlam=4,maxjt=223,		&
	ns_t=ns/nqrt,nfi=2,nrho=2,ntha=2+nlam+nfi+nrho+nadk+2
	integer i,ii,ibeg,iend,j,jj,k,jt,m,d,t,f,jbeg,jend,nprod_t(nqrt),sumprodt,numgrad,nits,gflag,numline,lflag,hflag,	&
	numhalf,age(nprod)			
	real*8 phi_ijt(ns_t,maxjt),etau_j,fi(nfi),rho(nrho),bigpsi(nadk),lam(nlam),demups(ns,nm),ad_jt(nprod,nm),		&
	a_jt(nprod,nm),thetaad(ntha),adp_t(nqrt,nm),dtau_ad(nprod,nm),aaphi_ijt(ns_t,maxjt),sumt,mtau_j,taubar(nprod),	&
	k_i(ns_t,nm),phitemp,aaphitemp,xad(nprod,3),d_ad(ns,14),bigpsif,gamad,nuad
	common/evals/numgrad,gflag,numline,lflag,hflag,numhalf
	common/demoups/demups						
	common/adchar/xad							
	common/pcage/age
	common/adprices/adp_t								
	common/tobs/nprod_t						
	common/kappa/k_i		
	common/adexp/ad_jt		
	common/ads/a_jt			
	common/dtauad/dtau_ad	
	common/antiphi/aaphi_ijt
	common/cps/d_ad						

	lam=thetaad(3:2+nlam)
	fi=thetaad(nlam+3:nlam+nfi+2)						
	rho=thetaad(nlam+nfi+3:nlam+nfi+nrho+2)			
	bigpsi=thetaad(3+nlam+nfi+nrho:ntha-2)
	gamad=thetaad(ntha-1)
	nuad=thetaad(ntha)

	sumprodt=0
	if (t .ge. 2) then
		do jt=1,t-1
			sumprodt=sumprodt+nprod_t(jt)
		enddo
	endif
	jbeg=sumprodt+1
	jend=sumprodt+nprod_t(t)
	ibeg=(t-1)*ns_t+1
	iend=t*ns_t
	phi_ijt=0.
	aaphi_ijt=0.
	taubar(jbeg:jend)=0.
	do j=jbeg,jend
		sumtau=0.
		f=xad(j,1)
		if (f .ge. 1) then
			bigpsif=bigpsi(f)
		else
			bigpsif=0.
		endif
		do m=1,nm
			ajt=ad_jt(j,m)
			a_jt(j,m)=ajt
			if (m .le. 2) then
				dtau_ad(j,m)=fi(1)+2*rho(1)*ajt+bigpsif			
				sumtau=sumtau+ajt*(fi(1)+rho(1)*ajt)
			elseif (m .eq. 3) then
				dtau_ad(j,m)=fi(2)+2*rho(2)*ajt+bigpsif			
				sumtau=sumtau+ajt*(fi(2)+rho(2)*ajt)
			else
				dtau_ad(j,m)=bigpsif			
			endif
		enddo
		taubar(j)=sumtau+xad(j,2)*bigpsif+gamad*age(j)
	enddo	
	ii=0
	do i=ibeg,iend
		ii=ii+1
		jj=0
		do j=jbeg,jend
			jj=jj+1
			tau_j=0.0
			mtau_j=0.0
			nuad=nuad/4.
			do m=1,nm
				ajt=a_jt(j,m)
				tau_j=tau_j+ajt*(k_i(ii,m)+nuad*demups(i,m))
				mtau_j=mtau_j+ajt*((1./k_i(ii,m))+nuad*demups(i,m))
			enddo
			sumtemp=taubar(j)+lam(1)+d_ad(i,5)*lam(2)+d_ad(i,6)*lam(3)+d_ad(i,14)*lam(4)
			tau_j=tau_j+sumtemp
			!for antithetic acceleration
			mtau_j=mtau_j+sumtemp
			if (tau_j .ge. 10.d0) then
				phi_ijt(ii,jj)=.99999d0
			else
				etau_j=dexp(tau_j)
				phitemp=etau_j/(1+etau_j)
				if (phitemp .eq. 1.d0) then
					phitemp=.99999d0
				endif
				phi_ijt(ii,jj)=phitemp
			endif
			if (mtau_j .ge. 10.d0) then
				aaphi_ijt(ii,jj)=.99999d0
			else
				etau_j=dexp(mtau_j)
				aaphitemp=etau_j/(1+etau_j)
				if (aaphitemp .eq. 1.d0) then
					aaphitemp=.99999d0
				endif
				aaphi_ijt(ii,jj)=aaphitemp
			endif
		enddo
	enddo

	return
	end subroutine ind_phi


	subroutine calcad(gam,smallpi,t,ad_jt)			
	!	-------------- computes advertising expenditures for model j -------------------

	use numerical_libraries
	use linear_operators

	implicit real*8 (a-h,o-z)
	integer, parameter :: nqrt=12,nm=4,nds=12,nups=nds*nm,nprod=2112,nven=180,nadk=9
	integer i,t,j,c,m,venad(nprod),qrt(nprod),venc(nven),qrtc(nven),nmod(nven),jbeg,jend,sumprodt,nprod_t(nqrt)
	real*8 ad_jt(nprod,nm),adgr_j,corpgr_cm,gam,smallpi
	common/tobs/nprod_t
	common/adven/venad
	common/adgroup/ad(nprod,nm),ad_gr(nprod,nm)		
	common/adtinfo/qrt
	common/corpadvars/venc,qrtc,nmod		
	common/corpad/corp(nven,nm)				
	common/venadprice/adp_ft(nven,nm)

	sumprodt=0
	if (t .ge. 2) then
		do jt=1,t-1
			sumprodt=sumprodt+nprod_t(jt)
		enddo
	endif
	jbeg=sumprodt+1
	jend=sumprodt+nprod_t(t)
	do j=jbeg,jend
		do m=1,nm
			sum=0.
			adgr_j=ad_gr(j,m)
			sum=ad(j,m)+gam*adgr_j+smallpi*adgr_j*adgr_j
			do c=1,nven
				if (qrt(j) .eq. qrtc(c) .and. venad(j) .eq. venc(c)) then
					corpgr_cm=corp(c,m)/nmod(c)
					sum=sum+gam*corpgr_cm+smallpi*corpgr_cm*corpgr_cm
					sum=sum/adp_ft(c,m)
				go to 160
				endif
			enddo
160			ad_jt(j,m)=sum
		enddo
	enddo

	return
	end subroutine calcad

	subroutine calcscore(parm,score,gradout)
	!	---- Calculate score and gradient ------------------
	
	use numerical_libraries
	use linear_operators

	implicit real*8 (a-h,o-z)
	integer, parameter :: nprod=2112,npichar=4,nchar=6,nm=4,nds=12,nups=nds*nm,nnlk=4,nk=13,nw=5,nnhk=4,nadk=9,nfirm=15,ncons=13400,	&
	nlam=4,nfi=2,nrho=2,ntha=2+nlam+nfi+nrho+nadk+2,nsmallpsi=2,netad=nsmallpsi+nnhk,nth=npichar+1+nnlk+ntha,nparm=nth+netad,	&
	nallparm=nparm+nups,nmom=6*nprod+5*ncons
	integer i,j,t,q,c,k,numgrad,nits,gflag,numline,lflag,hflag,numhalf,adflag,errflag,mediaflag
	real*8  parm(nallparm),score(nallparm),dparm(nmom,nallparm),gradout(nallparm,nallparm),obj_i(nmom),objplus_i(nmom),small(nallparm), &
	dev(nallparm),scoretemp(nallparm),obj,objplus
	common/evals/numgrad,gflag,numline,lflag,hflag,numhalf
	common/errflags/errflag
	common/objfunct/obj

	small=dabs(parm)/100. 
	where (small .lt. .0001d0) small=.0001d0
	adflag=0
	mediaflag=0

	score=0.
	do k=1,nallparm
		print*, 'calculating score for parameter', k
		write(320,*) 'calculating score for parameter', k
		parm(k)=parm(k)+small(k)
		objplus=0.		
		call gmmobj(parm,objplus)
		if (errflag .eq. 1) then
			errflag=0
		endif
		score(k)=(objplus-obj)/small(k)
		parm(k)=parm(k)-small(k)	
	enddo

	obj_i=0.
	call gmmobj_i(adflag,mediaflag,parm,obj_i)
	dparm=0.
	do k=1,nth
		print*, 'gradient for parameter', k
		write(320,*) 'gradient for parameter', k
		parm(k)=parm(k)+small(k)
		objplus_i=0.		
		call gmmobj_i(adflag,mediaflag,parm,obj_i)
		if (errflag .eq. 1) then
			errflag=0
		endif
		do i=1,6*nprod
			dparm(i,k)=(objplus_i(i)-obj_i(i))/small(k)
		enddo
		parm(k)=parm(k)-small(k)	
	enddo

	mediaflag=1
	do k=nth+1,nth+nups
		parm(k)=parm(k)+small(k)
		objplus_i=0.		
		call gmmobj_i(adflag,mediaflag,parm,obj_i)
		if (errflag .eq. 1) then
			errflag=0
		endif
		do i=1,nmom
			dparm(i,k)=(objplus_i(i)-obj_i(i))/small(k)
		enddo
		parm(k)=parm(k)-small(k)	
	enddo

	adflag=1
	do k=nth+nups+1,nallparm
		parm(k)=parm(k)+small(k)
		objplus_i=0.		
		call gmmobj_i(adflag,mediaflag,parm,obj_i)
		if (errflag .eq. 1) then
			errflag=0
		endif
		do i=2*nprod+1,6*nprod
			dparm(i,k)=(objplus_i(i)-obj_i(i))/small(k)
		enddo
		parm(k)=parm(k)-small(k)	
	enddo

	print*, 'finished computing outer product of gradient'
	write(320,*) 'finished computing outer product of gradient'
	gradout=0.
	gradout=matmul(transpose(dparm),dparm)	

	return
	end subroutine calcscore

	subroutine gmmobj_i(adflag,mediaflag,parm,obj_i)
	
	use numerical_libraries

	implicit real*8 (a-h,o-z)
	integer, parameter :: nprod=2112,nk=13,nw=5,nnlk=4,nm=4,nds=12,nups=nds*nm,npichar=4,nchar=6,nnhk=4,ncons=13400,nadk=9,nqrt=12,		&
	nfirm=15,nlam=4,nthl=nk+nw,nfi=2,nrho=2,ntha=2+nlam+nfi+nrho+nadk+2,nsmallpsi=2,netad=nsmallpsi+nnhk,				&
	nth=npichar+1+nnlk+ntha,nparm=nth+netad,nallparm=nparm+nups,niv=3*nth+nparm+nups,nmom=6*nprod+5*ncons		
	integer i,q,m,ii,f,k,t,j,v,z,zz,adflag,errflag,mediaflag
	real*8 obj_i(nmom),parm(nallparm),theta(nth),upsilon(nups),z_xi(nprod,nth),z_w(nprod,nth),xi,errz(nallparm),omega,adres(nprod,nm),	&
	aderr(nm),z_ad(nprod,nm,nparm),microres(ncons,nfirm),z_media(ncons,5,nups),mediares(ncons,nm,5),z_micro(ncons,nfirm,nth),x(nprod,nk),w(nprod,nw),			&
	xnl(nprod,nnlk),invaxi(nth,nth),invaw(nth,nth),invaad(nparm,nparm),invamicro(nth,nth),invamedia(nups,nups)
	real*8 bta(nk),eta(nw),xz(nk,nth),invbeta(nk,nk),wz(nw,nth),inveta(nw,nw),zdelta(nth),zmc(nth),xzazy(nk),wzazy(nw), &
	xzzy(nk),wzzy(nw)
	real*8, dimension(nprod) :: delta_jt,expdelta,mc,sims_jt,lnmc
	common/vars/x,xnl,w
	common/instr/z_xi,z_w 		
	common/adinstr/z_ad	
	common/microinstr/z_micro	
	common/mediainstr/z_media
	common/edel/expdelta 
	common/thetalinear/xz,wz,invbeta,inveta
	common/weightmatparts/invaxi,invaw,invaad,invamicro
	common/weightmatmedia/invamedia
	common/errflags/errflag

	theta=parm(1:nth)
	obj_i=0.
	weightprod=1.
	weightsim=1.

	if (adflag .eq. 0) then
		if (mediaflag .eq. 1) then
			upsilon=parm(nth+1:nth+nups)
			call mediamom(upsilon,mediares)
		endif
		call meanval(theta,delta_jt)
		expdelta=dexp(delta_jt)
		if (errflag .eq. 1) then
			obj_i=1.d15
			go to 60
		endif
		call mom(parm,mc,adres)
		if (errflag .eq. 1) then
			obj_i=1.d15
			go to 60
		endif
		lnmc=dlog(mc)
		call micro(theta,microres)
		zdelta=matmul(transpose(z_xi),delta_jt)
		zmc=matmul(transpose(z_w),lnmc)
		xzazy=matmul(matmul(xz,invaxi),zdelta)
		wzazy=matmul(matmul(wz,invaw),zmc)
		bta=matmul(invbeta,xzazy)
		eta=matmul(inveta,wzazy)

		do i=1,nprod
			xbeta=0.
			do k=1,nk
				xbeta=xbeta+x(i,k)*bta(k)			
			enddo
			xi=delta_jt(i)-xbeta
			errz=0.
			do z=1,nth			
				errz(z)=xi*z_xi(i,z)
			enddo
			obji=0.
			do z=1,nth
				do v=1,nth
					obji=obji+errz(v)*invaxi(v,z)*errz(z)
				enddo
			enddo
			obj_i(i)=obji/weightprod
		enddo
		do i=nprod+1,2*nprod
			j=i-nprod
			weta=0.
			do k=1,nw
				weta=weta+w(j,k)*eta(k)			
			enddo			
			omega=lnmc(j)-weta
			errz=0.
			do z=1,nth					
				errz(z)=omega*z_w(j,z)
			enddo
			obji=0.
			do z=1,nth
				do v=1,nth
					obji=obji+errz(v)*invaw(v,z)*errz(z)
				enddo
			enddo
			obj_i(i)=obji/weightprod
		enddo
		do i=2*nprod+1,6*nprod
			errz=0.				
			if (i .le. 3*nprod) then
				j=i-2*nprod							
				do z=1,nparm
					errz(z)=adres(j,1)*z_ad(j,1,z)	
				enddo
			elseif (i .le. 4*nprod) then 
				j=i-3*nprod
				do z=1,nparm
					errz(z)=adres(j,2)*z_ad(j,2,z)					
				enddo
			elseif (i .le. 5*nprod) then 
				j=i-4*nprod
				do z=1,nparm
					errz(z)=adres(j,3)*z_ad(j,3,z)
				enddo
			else
				j=i-5*nprod
				do z=1,nparm
					errz(z)=adres(j,4)*z_ad(j,4,z)	
				enddo
			endif				
			obji=0.
			do z=1,nparm
				do v=1,nparm
					obji=obji+errz(v)*invaad(v,z)*errz(z)
				enddo
			enddo
			obj_i(i)=obji/weightprod
		enddo		

		ii=6*nprod
		do i=1,ncons
			ii=ii+1
			errz=0.
			do f=1,3
				do z=1,nth
					errz(z)=errz(z)+microres(i,f)*z_micro(i,f,z)
				enddo
			enddo
			if (i .le. 6700) then
				do f=5,nfirm
					do z=1,nth
						errz(z)=errz(z)+microres(i,f)*z_micro(i,f,z)
					enddo
				enddo
			else
				do f=5,7
					do z=1,nth
						errz(z)=errz(z)+microres(i,f)*z_micro(i,f,z)
					enddo
				enddo
				do f=9,12
						do z=1,nth
						errz(z)=errz(z)+microres(i,f)*z_micro(i,f,z)
					enddo
				enddo
				do f=13,14
					do z=1,nth
						errz(z)=errz(z)+microres(i,f)*z_micro(i,f,z)
					enddo
				enddo
			endif

			obji=0.
			do z=1,nth
				do v=1,nth
					obji=obji+errz(v)*invamicro(v,z)*errz(z)
				enddo
			enddo
			obj_i(ii)=obji/weightsim
		enddo

		if (mediaflag .eq. 1) then
			do i=1,ncons*4
				ii=ii+1
				errz=0.
				do q=1,5
					zz=0
					do z=nparm+1,nparm+nds
						zz=zz+1
						errz(z)=errz(z)+mediares(i,1,q)*z_media(i,q,zz)
					enddo
					zz=0
					do z=nparm+nds+1,nparm+2*nds
						zz=zz+1
						errz(z)=errz(z)+mediares(i,2,q)*z_media(i,q,zz)
					enddo
					zz=0
					do z=nparm+2*nds+1,nparm+3*nds
						zz=zz+1
						errz(z)=errz(z)+mediares(i,3,q)*z_media(i,q,zz)
					enddo
					zz=0
					do z=nparm+3*nds+1,nallparm
						zz=zz+1
						errz(z)=errz(z)+mediares(i,4,q)*z_media(i,q,zz)
					enddo
				enddo
				obji=0.
				zz=0
				do z=nparm+1,nallparm
					zz=zz+1
					vv=0
					do v=nparm+1,nallparm
						vv=vv+1
						obji=obji+errz(v)*invamedia(vv,zz)*errz(z)
					enddo
				enddo
				obj_i(ii)=obji/weightsim
			enddo
		endif
	else
		call meanval(theta,delta_jt)
		call mom(parm,mc,adres)
		if (errflag .eq. 1) then
			obj_i=1.d15
			go to 60
		endif

		do i=2*nprod+1,6*nprod
			if (i .le. 3*nprod) then
				j=i-2*nprod							
				errz=0.
				do z=1,nparm
					errz(z)=adres(j,1)*z_ad(j,1,z)	
				enddo
			elseif (i .le. 4*nprod) then 
				j=i-3*nprod
				errz=0.
				do z=1,nparm
					errz(z)=adres(j,2)*z_ad(j,2,z)					
				enddo
			elseif (i .le. 5*nprod) then 
				j=i-4*nprod
				errz=0.
				do z=1,nparm
					errz(z)=adres(j,3)*z_ad(j,3,z)
				enddo
			else
				j=i-5*nprod
				errz=0.
				do z=1,nparm
					errz(z)=adres(j,4)*z_ad(j,4,z)	
				enddo
			endif				
			obji=0.
			do z=1,nparm
				do v=1,nparm
					obji=obji+errz(v)*invaad(v,z)*errz(z)
				enddo
			enddo
			obj_i(i)=obji/weightprod
		enddo
	endif
60	continue

	return 
	end subroutine gmmobj_i


	subroutine calcweight
	!	---------------calculate the weighting matrix ------------------

	use numerical_libraries

	implicit real*8 (a-h,o-z)
	integer, parameter :: nprod=2112,nk=13,nw=5,nnlk=4,nm=4,nds=12,nups=nds*nm,npichar=4,nchar=6,nnhk=4,ncons=13400,nqrt=12,nfirm=15,	&
	nadk=9,nlam=4,nthl=nk+nw,nfi=2,nrho=2,ntha=2+nlam+nfi+nrho+nadk+2,nsmallpsi=2,netad=nsmallpsi+nnhk,				&
	nth=npichar+1+nnlk+ntha,nparm=nth+netad,nallparm=nparm+nups,niv=3*nth+nparm+nups,nmom=6*nprod+5*ncons
	integer i,ii,iq,t,f,v,k,vv,j,jj,z
	real*8 	adres(nprod,nm),microres(ncons,nfirm),z_xi(nprod,nth),z_w(nprod,nth),z_ad(nprod,nm,nparm),	&
	z_micro(ncons,nfirm,nth),zadm(nprod,nparm),zmicro(ncons,nth),zm(nth),inva(niv,niv),invaxi(nth,nth), &
	zerrth(nth),errzth(1,nth),aath(nth,nth),invaw(nth,nth),invaad(nparm,nparm),invamicro(nth,nth),invamedia(nups,nups),errzparm(1,nparm),	&
	zerrparm(nparm),aaparm(nparm,nparm),errzmicro(1,nth),aamicro(nth,nth),zerrups(nups),errzups(1,nups),aamedia(nups,nups)
	real*8 xz(nk,nth),invbeta(nk,nk),wz(nw,nth),inveta(nw,nw),zxaxz(nk,nk),zwawz(nw,nw)
	real*8, dimension(nprod) :: xi,omega
	real*8 medresm(ncons,5),zmedm(ncons,5,nds),par,mediares(ncons,nm,5),z_media(ncons,5,nups),zmedmq(ncons,nds),zmd(nds)
	common/thetalinear/xz,wz,invbeta,inveta
	common/weightmat/inva
	common/weightmatparts/invaxi,invaw,invaad,invamicro
	common/weightmatmedia/invamedia
	common/instr/z_xi,z_w
	common/adinstr/z_ad	
	common/microinstr/z_micro	
	common/mediainstr/z_media

	open(25, file='c:\michelle\pcad\programs\main\results\omega.txt')
	open(30, file='c:\michelle\pcad\programs\main\results\xi.txt')
	open(40, file='c:\michelle\pcad\programs\main\results\adres.txt')
	open(55, file='c:\michelle\pcad\programs\main\results\microres.txt')
	open(51, file='c:\michelle\pcad\programs\main\results\mediaresnp.txt')
	open(52, file='c:\michelle\pcad\programs\main\results\mediaresmag.txt')
	open(53, file='c:\michelle\pcad\programs\main\results\mediarestv.txt')
	open(54, file='c:\michelle\pcad\programs\main\results\mediaresrad.txt')

	do j=1,nprod			
		read(25,210)omega(j)
		read(30,210)xi(j)
	enddo	
	close(25)
	close(30)
	do j=1,nprod
		read(40,220)(adres(j,m),m=1,nm)
	enddo
	close(40)
	do i=1,ncons
		read(55,230)(microres(i,v),v=1,15)
		read(51,231)(mediares(i,1,iq),iq=1,5)
		read(52,231)(mediares(i,2,iq),iq=1,5)
		read(53,231)(mediares(i,3,iq),iq=1,5)
		read(54,231)(mediares(i,4,iq),iq=1,5)
	enddo
	close(55)
	close(51)
	close(52)
	close(53)
	close(54)

210	format(1x,d15.7) 
220	format(4(1x,d15.7)) 
230	format(15(1x,d15.7)) 
231	format(5(1x,d15.7)) 
	
	inva=0.

	!(z_xi' xi)'(z_xi' xi)
	zerrth=0.
	zerrth=matmul(transpose(z_xi),xi)

	invaxi=0.
	errzth(1,:)=zerrth
	aath=0.
	aath=matmul(transpose(errzth),errzth)
	call dlinrg(nth,aath,nth,invaxi,nth)
	inva(1:nth,1:nth)=invaxi

	!(z_w' omega)'(z_w' omega)
	zerrth=0.
	zerrth=matmul(transpose(z_w),omega)
	invaw=0.
	errzth(1,:)=zerrth
	aath=0.
	aath=matmul(transpose(errzth),errzth)
	call dlinrg(nth,aath,nth,invaw,nth)
	inva(nth+1:2*nth,nth+1:2*nth)=invaw

	!(z_ad' adres)'(z_ad' adres)
	zadm=0.
	zerrparm=0.
	do m=1,nm
		zadm=z_ad(:,m,:)
		zerrparm=zerrparm+matmul(transpose(zadm),adres(:,m))
	enddo
	invaad=0.
	errzparm(1,:)=zerrparm
	aaparm=0.
	aaparm=matmul(transpose(errzparm),errzparm)
	call dlinrg(nparm,aaparm,nparm,invaad,nparm)
	inva(2*nth+1:2*nth+nparm,2*nth+1:2*nth+nparm)=invaad	

	!(z_micro' microres)'(z_micro' microres)
	zmicro=0.
	zm=0.
	do f=1,3
		zmicro=z_micro(:,f,:)	
		zm=zm+matmul(transpose(zmicro),microres(:,f))
	enddo
	do f=5,nfirm
		zmicro=z_micro(:,f,:)	
		zm=zm+matmul(transpose(zmicro),microres(:,f))
	enddo
	invamicro=0.	
	errzth(1,:)=zm
	aamicro=0.
	aamicro=matmul(transpose(errzth),errzth)			
	call dlinrg(nth,aamicro,nth,invamicro,nth)
	inva(2*nth+nparm+1:3*nth+nparm,2*nth+nparm+1:3*nth+nparm)=invamicro

	!(z_media' mediares)'(z_media' mediares)
	medresm=0.
	zmedm=0.
	par=3*nth+nparm
	do m=1,nm
		medresm=mediares(:,m,:)
		zmedm=z_media(:,:,(m-1)*nds+1:m*nds)
		zmedmq=0.
		zmd=0.
		do iq=1,5
			zmedmq=zmedm(:,iq,:)
			zmd=zmd+matmul(transpose(zmedmq),medresm(:,iq))
		enddo
		zerrups((m-1)*nds+1:m*nds)=zmd
	enddo

	invamedia=0.
	errzups(1,:)=zerrups
	aamedia=0.
	aamedia=matmul(transpose(errzups),errzups)			
	call dlinrg(nups,aamedia,nups,invamedia,nups)
	inva(3*nth+nparm+1:niv,3*nth+nparm+1:niv)=invamedia

	open(91,file='c:\michelle\pcad\programs\main\results\updatedinva.txt')
	do z=1,niv
		do v=1,niv
		 write(91,210)inva(z,v)
		enddo
	enddo

	!for beta and eta calculation
	zxaxz=matmul(matmul(xz,invaxi),transpose(xz))
	invbeta=0.
	call dlinrg(nk,zxaxz,nk,invbeta,nk)
	zwawz=matmul(matmul(wz,invaw),transpose(wz))
	inveta=0.
	call dlinrg(nw,zwawz,nw,inveta,nw)

	return 
	end subroutine calcweight

!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!  DATA:		See supplement guide and readme file for more detail.
!
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	subroutine prodget
	!	--------------- Gets product data ----------------------------

	implicit real*8 (a-h, o-z)
	integer, parameter :: nqrt=12,nk=13,nnlk=4,nprod=2112,nadk=9,nw=5,nven=15,allprd=2869
	integer i,t,k,r,j,jj,v,jt,jbeg,jend,tdum96(allprd),tdum(allprd,nqrt-1),nprodt(nqrt), &
	texas(allprd),hhs(29),vend(allprd,14),pent(allprd,3),sumprodt,	&
	totven(nven),ven(nprod),qrt(nprod),cnt,nprod_t(nqrt),incl_j(allprd),age(nprod)
	integer, dimension(allprd) :: ids,vendor,brd,cput,ff,quarter,idnh,lap,cpus,ageall
	real datas_jt(allprd)
	real*8 tempsal(nven,3),allsal(nven,nqrt),vsalpc(nven),x(nprod,nk),s_firm(nven,2), &
	xnl(nprod,nnlk),w(nprod,nw)
	real*8, dimension(allprd) :: idmodel,idprod,sales,pjt,sjt,idmodelnh,idprodnh,	&
	salnh,pnhjt,snhjt,salesoth
	real*8, dimension(nprod) :: s_jt,p_jt,pnh_jt,sal,saloth,snh_jt,idj,xiv(nprod,3)
	common/deflator/cpi(29)
	common/vars/x,xnl,w
	common/pcage/age
	common/vendor/ven	
	common/tobs/nprod_t					
	common/share/s_jt,sal
	common/price/p_jt		
	common/numhhs/hhs
	common/nonhome/pnh_jt			
	common/allsales/saloth	
	common/products/incl_j
	common/xinstru/xiv
	open(15, file='c:\michelle\pcad\programs\main\nobs.txt')	   
	open(20, file='c:\michelle\pcad\programs\main\salesmain.txt')	      
	open(30, file='c:\michelle\pcad\programs\main\nonhome.txt')
	open(40, file='c:\michelle\pcad\programs\main\allcomp.txt')	 		 	
	open(21, file='c:\michelle\pcad\programs\main\salesage.txt')	      	


	read(15,'(i3)')(nprodt(t),t=1,nqrt)
	do i=1,allprd
		read(20,110)idprod(i),idmodel(i),ids(i),vendor(i),brd(i),cput(i),cpus(i),ff(i),	&
		pent(i,1:3),lap(i),vend(i,1:14),texas(i),tdum96(i),tdum(i,1:nqrt-1),quarter(i),sales(i),datas_jt(i),pjt(i)
		read(30,120)idprodnh(i),idmodelnh(i),idnh(i),salnh(i),pnhjt(i)
		read(21,111)ageall(i)
	enddo
	do v=1,nven
		read(40,140)totven(v),tempsal(v,1:3)
	enddo	 

110	format(f17.0,1x,f18.0,1x,i10,1x,i9,1x,i9,1x,i9,1x,i9,1x,i9,3(1x,i9),1x,i9,15(1x,i9),12(1x,i9),1x,i10,1x,f13.0,1x,f11.8,1x,d15.8)
!		   idprod  idmodel   id    ven#   br    cpt   cps   ff cputdum   lap  ven dum   tim dum   quarter  sales   share     prices

111	format(i9)
!		  age 

120	format(f17.0,1x,f18.0,1x,i10,1x,f13.0,1x,d15.8)
!		 idprod idmodel  id   sales   prices

140 format(i3,3(1x,f13.7))
!			ven		sales

	!deflate 
	allsal(:,1)=tempsal(:,1)
	allsal(:,2)=tempsal(:,1)
	allsal(:,3)=tempsal(:,1)
	allsal(:,4)=tempsal(:,1)
	allsal(:,5)=tempsal(:,2)
	allsal(:,6)=tempsal(:,2)
	allsal(:,7)=tempsal(:,2)
	allsal(:,8)=tempsal(:,2)
	allsal(:,9)=tempsal(:,3)
	allsal(:,10)=tempsal(:,3)
	allsal(:,11)=tempsal(:,3)
	allsal(:,12)=tempsal(:,3)
	do t=1,nqrt
		allsal(:,t)=allsal(:,t)/cpi(t+4)
	enddo

	saloth=0.
	do t=1,nqrt
		sumprodt=0
		if (t .ge. 2) then
			do jt=1,t-1
				sumprodt=sumprodt+nprodt(jt)
			enddo
		endif
		jbeg=sumprodt+1
		jend=sumprodt+nprodt(t)

		!construct dollar sales for pc market (home and non-home)
		vsalpc=0.
		do j=jbeg,jend
			v=vendor(j)
			if (v .eq. 15) then
				v=14
			elseif (v .eq. 17) then
				v=15
			endif
			vsalpc(v)=vsalpc(v)+(sales(j)*pjt(j)+salnh(j)*pnhjt(j))/1000000			
		enddo

		!construct allsales-pcsales
		do j=jbeg,jend
			v=vendor(j)
			if (v .eq. 15) then
				v=14
			elseif (v .eq. 17) then
				v=15
			endif
			salesoth(j)=allsal(v,t)-vsalpc(v)
			if (salesoth(j) .lt. 0.d0) then
				salesoth(j)=0.d0
			endif
		enddo
	enddo

	sjt=0.
	snhjt=0.
	do j=1,allprd
		if (quarter(j) .le. 4) then 
			sjt(j)=sales(j)/(hhs(25)*1000)
			snhjt(j)=salnh(j)/(hhs(25)*1000)
		elseif (quarter(j) .le. 8) then
			sjt(j)=sales(j)/(hhs(26)*1000)
			snhjt(j)=salnh(j)/(hhs(26)*1000)
		else
			sjt(j)=sales(j)/(hhs(27)*1000)
			snhjt(j)=salnh(j)/(hhs(27)*1000)
		endif
	enddo

	!2112 when eliminate those with s_jt .le. 1.e-6
	incl_j=1
	do j=1,allprd
		if (sjt(j) .le. 1.e-6) then
			incl_j(j)=0
		endif
	enddo

	jj=0
	do j=1,allprd
		if (incl_j(j) .eq. 1) then
			jj=jj+1
			s_jt(jj)=sjt(j)
			snh_jt(jj)=snhjt(j)
			p_jt(jj)=pjt(j)
			pnh_jt(jj)=pnhjt(j)
			sal(jj)=sales(j)
			saloth(jj)=salesoth(j)
			ven(jj)=vendor(j)
			x(jj,2)=cpus(j)
			x(jj,3)=pent(j,1)+pent(j,2)+pent(j,3)							
			x(jj,4)=lap(j)
			x(jj,5:6)=vend(j,1:2)
			x(jj,7:8)=vend(j,5:6)
			x(jj,9:12)=vend(j,9:12)
			x(jj,13)=vend(j,14)
			qrt(jj)=quarter(j)
			age(jj)=ageall(j)	
			!xiv(jj,1)=cput(j)
			!xiv(jj,2)=ff(j)
			!xiv(jj,3)=quarter(j)
		endif
	enddo

	do t=1,nqrt
		cnt=0
		do j=1,nprod
			if (qrt(j) .eq. t) then
				cnt=cnt+1
			endif
		enddo
		nprod_t(t)=cnt
	enddo
	w(:,1)=1
	w(:,2)=dlog(x(:,2))		
	w(:,3:4)=x(:,3:4)
	w(:,5)=qrt
	x(:,1)=1.
	x(:,2)=x(:,2)/800.		!rescale cpuspeed 
	xnl=x(:,1:4)

	open(101, file='c:\michelle\pcad\programs\main\x.txt')
	open(103, file='c:\michelle\pcad\programs\main\w.txt')
	open(102, file='c:\michelle\pcad\programs\main\xnl.txt')
	open(104, file='c:\michelle\pcad\programs\main\s_jt.txt')
	do j=1,nprod
		write(103,200)(w(j,k),k=1,nw)
		write(101,201)(x(j,k),k=1,nk)
		write(102,202)(xnl(j,k),k=1,nnlk)
		write(104,203)s_jt(j)
	enddo

200	format(6(1x,d15.7)) 
201	format(13(1x,d15.7)) 
202	format(3(1x,d15.7)) 
203	format(d15.7) 

	s_firm=0.
	do j=1,nprod
		v=ven(j)
		if (v .eq. 15) then
			v=14
		elseif (v .eq. 17) then
			v=15
		endif
		if (qrt(j) .le. 4) then
			s_firm(v,1)=s_firm(v,1)+s_jt(j)				
		elseif (qrt(j) .le. 8) then
			s_firm(v,2)=s_firm(v,2)+s_jt(j)
		endif
	enddo

	open(10, file='c:\michelle\pcad\programs\main\obsfirmshares.txt')
	do i=1,nven
		write(10,300)(s_firm(i,k),k=1,2)
	enddo
	close(10)
	write(6,*) 'writing include j'
	open(11, file='c:\michelle\pcad\programs\main\includedfirms.txt')
	do i=1,allprd
		write(11,301)incl_j(i)
	enddo
301 format(i3)
300	format(2(1x,d15.7)) 

	close(11)
	close(15)
	close(20)
	close(30)
	close(40)

	return	
	end subroutine prodget

		subroutine adget		
	!	--------------- Gets ad data ----------------------------

	implicit real*8 (a-h, o-z)		
	integer, parameter :: nqrt=12,nall=16788,nm=4,nds=12,nups=nds*nm,nprod=2112,nadk=9,allprd=2869,nven=180
	integer aj,j,jj,jt,i,t,k,xchar(allprd,24),qrt(nprod),tdum(allprd,nqrt),bigad(allprd,37),venad(nprod),&
	quarter(allprd),incl_j(allprd),qrtn
	real adpricetemp(16,nm)
	real*8 idproda(allprd),idmodela(allprd),idall(nall,2),adexp(nall,8),adp_t(nqrt,nm),		&
	adprice(16,nm),adexps(allprd,nm),adexp_gr(allprd,nm),xad(nprod,3),totad(nven)
	common/adchar/xad								
	common/adven/venad								
	common/firmad/totad								
	common/adgroup/ad(nprod,nm),ad_gr(nprod,nm)		!ad order: np, mag, tv, other	   
	common/adtinfo/qrt
	common/adprices/adp_t							!ad prices order: np, mag, tv, other	   
	common/deflator/cpi(29)
	common/products/incl_j

	!ad exp for models with sales (order: all,np,mag,tv group: other,np,mag,tv 	   
	open(41, file='c:\michelle\pcad\programs\main\admain.txt')
	do i=1,allprd
		read(41,140)idproda(i),idmodela(i),xchar(i,1:24),tdum(i,1:nqrt),adexps(i,4),  &
		adexps(i,1),adexps(i,2),adexps(i,3),adexp_gr(i,4),adexp_gr(i,1),adexp_gr(i,2), &
		adexp_gr(i,3),quarter(i)
	enddo
140	format(f17.0,1x,f18.0,1x,i9,1x,i9,1x,i9,1x,i9,1x,i9,3(1x,i9),1x,i9,15(1x,i9),12(1x,i9),4(1x,d13.5),4(1x,d13.5),1x,i10)
!		   idprod  idmodel  ven#   br    cpt   cps   ff cputdum     lap ven dum   time dum		ad     ad group      quarter

	jj=0
	xad(:,1)=0
	xad(:,2)=0.
	xad(:,3)=0.
	do j=1,allprd
		if (incl_j(j) .eq. 1) then
			jj=jj+1
			venad(jj)=xchar(j,1)
			qrt(jj)=quarter(j)
			qrtn=quarter(j)
			if (xchar(j,1) .eq. 1) then
				xad(jj,1)=1
				xad(jj,2)=totad(15*(qrtn-1)+1)
			elseif (xchar(j,1) .eq. 2) then
				xad(jj,1)=2
				xad(jj,2)=totad(15*(qrtn-1)+2)
			elseif (xchar(j,1) .eq. 5) then
				xad(jj,1)=3
				xad(jj,2)=totad(15*(qrtn-1)+5)
			elseif (xchar(j,1) .eq. 6) then
				xad(jj,1)=4
				xad(jj,2)=totad(15*(qrtn-1)+6)
			elseif (xchar(j,1) .eq. 9) then
				xad(jj,1)=5
				xad(jj,2)=totad(15*(qrtn-1)+9)
			elseif (xchar(j,1) .eq. 10) then
				xad(jj,1)=6
				xad(jj,2)=totad(15*(qrtn-1)+10)
			elseif (xchar(j,1) .eq. 11) then
				xad(jj,1)=7
				xad(jj,2)=totad(15*(qrtn-1)+11)
			elseif (xchar(j,1) .eq. 12) then
				xad(jj,1)=8
				xad(jj,2)=totad(15*(qrtn-1)+12)
			elseif (xchar(j,1) .eq. 15) then
				xad(jj,1)=9
				xad(jj,2)=totad(15*(qrtn-1)+15)
			endif
			xad(jj,3)=xchar(j,4)/800		!cpuspeed/800
			ad(jj,:)=adexps(j,:)
			ad_gr(jj,:)=adexp_gr(j,:)
		endif
	enddo

	do i=1,nprod
		ad(i,4)=ad(i,4)-ad(i,1)-ad(i,2)-ad(i,3)
		if (ad(i,4) .lt. 1.d-10) then
			ad(i,4)=0.
		endif
	enddo
	open(80, file='c:\michelle\pcad\programs\main\adprice.txt')
	do i=1,16
		read(80,141)adpricetemp(i,1:4)
	enddo
	adprice=dble(adpricetemp)
	adp_t=adprice(5:16,:)
	do i=1,nqrt
		adp_t(i,:)=adp_t(i,:)/cpi(i+4)
	enddo

141	format(f5.2,1x,f5.2,1x,f4.2,1x,f6.2)
	!		np      mag     tv      other
	close(41)
	close(42)

	return	
	end subroutine adget


	subroutine vendget		
	!	--------------- Gets vendor level data including corp advertising-------------

	implicit real*8 (a-h, o-z)
	integer, parameter :: nqrt=12,nven=180,nm=4,nds=12,nups=nds*nm,nfirm=15
	integer i,f,k,t,nv,v,vtdum(nven,nqrt),ven(nven,3),hhs(29),nprod_v(nqrt,nfirm)
	integer, dimension(nven) :: vqrt,venc,qrtc,nmod,nprodv
	real datas_vt(nven)
	real*8 vad(nven,nm),vprice(nven),vsal(nven),s_firm(nfirm,2),totad(nven) !s_vt(nven)
	common/corpadvars/venc,qrtc,nmod		
	common/corpad/corp(nven,nm)				!corp: ad np, mag,tv,other
	common/firmad/totad						!total ad expenditures for vendors
	common/venadprice/adp_ft(nven,nm)		
	common/deflator/cpi(29)

	open(30, file='c:\michelle\pcad\programs\main\vmain.txt')	!vad order: other, np, mag, tv
    open(50, file='c:\michelle\pcad\programs\main\corp.txt')	!corp ad: all, np, mag,tv
	open(60, file='c:\michelle\pcad\programs\main\nprodven.txt')
	do i=1,nven
		read(30,130)ven(i,1:3),vtdum(i,1:nqrt),vsal(i),datas_vt(i),vad(i,4),vad(i,1),	&
		vad(i,2),vad(i,3),vprice(i),vqrt(i)
		read(50,150)venc(i),nmod(i),corp(i,4),corp(i,1),corp(i,2),corp(i,3),qrtc(i),	&
		adp_ft(i,1),adp_ft(i,2),adp_ft(i,3),adp_ft(i,4)
	enddo
	do i=1,nven
		read(60,'(i3)')nprodv(i)
	enddo
130	format(1x,f14.0,1x,i9,1x,i9,12(1x,i9),1x,f13.0,1x,f11.8,4(1x,d13.5),1x,d13.5,1x,i9)
!				idven  ven  nmod  time dum  sales   share     ad exp     prices   quarter
150	format(i8,1x,i9,4(1x,d13.5),1x,i9,4(1x,d13.5))  
!		   ven  nmod   corp ad     qrt	adp_ft

	close(30)
	close(50)
	close(60)

	totad=vad(:,1)+vad(:,2)+vad(:,3)+vad(:,4)
	totad=totad/100000.
	nv=0
	do t=1,nqrt		
		do f=1,nfirm
			nv=nv+1
			nprod_v(t,f)=nprodv(nv)
			adp_ft(nv,:)=adp_ft(nv,:)/cpi(t+4)
		enddo
	enddo

	!sometimes due to precision corp(i,4) is very small, if so should be zero
	do i=1,nven
		corp(i,4)=corp(i,4)-corp(i,1)-corp(i,2)-corp(i,3)
		if (corp(i,4) .lt. 1.d-10) then
			corp(i,4)=0.
		endif
	enddo	

	return	
	end subroutine vendget


	subroutine cpsget		
	!	------------ Draw "individual" demographics from sampling CPS -------------

	implicit real*8 (a-h, o-z)
	integer, parameter :: ns=9000,nchar=6,nlamchar=13,nprod=2112
	integer i,j,k,cps(ns,nlamchar),yr(ns),tempd_i(ns,nchar)
	real*8 cpsmean(nchar),inc(ns),d_ad(ns,14)	
	common/cps/d_ad								
	common/cpsdemean/d_i(ns,nchar)				
	common/income/inc			
	common/deflator/cpi(29)						!rows 24-29 contain annual deflators

	open(105,file='c:\michelle\pcad\programs\main\cpsmain.txt')				
	do i=1,ns
		read(105,180)yr(i),cps(i,1:4),cps(i,7:11),inc(i)
	enddo
180 format (i8,9(1x,i9),1x,f13.0)

	cps(:,12:13)=0
	do i=1,ns
		if (yr(i) .eq. 96) then
			inc(i) = inc(i)/cpi(25)
			cps(i,12)=1
		elseif (yr(i) .eq. 97) then
			inc(i) = inc(i)/cpi(26)
			cps(i,13)=1
		endif
	enddo
	cps(:,5:6)=0
	where (inc .le. 60000.d0)	
		cps(:,5)=1							
	elsewhere (inc .ge. 100000.d0)	
		cps(:,6)=1							
	endwhere
	d_ad(:,1:13)=real(cps)
	d_ad(:,12)=1
	d_ad(:,14)=d_ad(:,8)+d_ad(:,9)+d_ad(:,10)	
	do i=1,ns
		tempd_i(i,1)=cps(i,1)	
		tempd_i(i,2:6)=cps(i,4:8)
	enddo
	d_i=real(tempd_i)
	!demean variables
	cpsmean = sum(d_i,dim=1)
	cpsmean=cpsmean/ns
	do i=1,ns
		d_i(i,1:nchar)=d_i(i,1:nchar)-cpsmean(1:nchar)
	enddo       

	close(105)

	return
	end subroutine cpsget

	subroutine consget

	!	--------------- Gets individual data ----------------------------

	implicit real*8 (a-h, o-z)     
	integer, parameter :: nobi=20100,nchar=6,nqrt=12,nnlk=4,nlamchar=13,ncons=13400,ncons_y=6700,nm=4,nds=12,nups=nds*nm
	integer i,j,k,t,demo(nobi,7),moredemo(nobi,20),pcchar(nobi,11),venown(nobi,17),			&
	quintile(nobi,20),location(nobi,3),yr(nobi),id(nobi),newpc(nobi),cchar(nobi,nlamchar),		&
	nsim,venpurch(ncons),pcnew(ncons),quintl(ncons,20),him(ncons,nm)
	integer, dimension (nobi,5) :: edu,magquin,npquin,tvquin,othquin
	real magpc(nobi)
	real*8 ccharmean(nchar),cchar_i(ncons,nchar),income(nobi),inc(ncons),		&
	pcprice(nobi),cchar_ad(ncons,nlamchar),thresh(4,nm),intups(4*nlamchar),pciv(ncons,2)
	common/conchar/cchar_ad		           
	common/simdemean/cchar_i
	common/siminc/inc				
	common/simpurch/venpurch,pcnew
	common/mediax/him						!order is np, mag, tv, radio 
	common/mediac/thresh					!order is np, mag, tv, radio 
	common/deflator/cpi(29)					!rows 24-29 contain annual deflators
	common/consints/pciv
		   
	open(60,file='c:\michelle\pcad\programs\main\consmain.txt')
	open(70,file='c:\michelle\pcad\programs\main\consquint.txt')
	do i=1,nobi
		read(60,160)yr(i),id(i),moredemo(i,1),demo(i,1:4),moredemo(i,2:16),income(i),	&
		moredemo(i,17:20),edu(i,1:2),edu(i,4),newpc(i),pcchar(i,1:2),pcprice(i),pcchar(i,3:11), &
		venown(i,1:17),location(i,1:3)
		read(70,170)quintile(i,1:20),magpc(i)
	enddo
160		format(i9,21(1x,i10),1x,d15.8,4(1x,i10),6(1x,i10),1x,f15.0,9(1x,i10),20(1x,i10)) 
!							  income						pcprice
170		format(i9,19(1x,i10),1x,f6.3)
!                              pcmag

	open(91,file='c:\michelle\pcad\programs\main\parmnp.txt')
	read(91,101)intups(1:nlamchar),thresh(1,1:4)
	open(92,file='c:\michelle\pcad\programs\main\parmmag.txt')
	read(92,101)intups(nlamchar+1:2*nlamchar),thresh(2,1:4)
	open(93,file='c:\michelle\pcad\programs\main\parmtv.txt')
	read(93,101)intups(2*nlamchar+1:3*nlamchar),thresh(3,1:4)	
	open(94,file='c:\michelle\pcad\programs\main\parmoth.txt')
	read(94,101)intups(3*nlamchar+1:4*nlamchar),thresh(4,1:4)	

101 format(13(1x,f11.7),4(1x,f11.7))

	magquin=quintile(1:nobi,1:5)
	npquin=quintile(1:nobi,6:10)
	tvquin=quintile(1:nobi,11:15)
	othquin=quintile(1:nobi,16:20)

	!some observations for which more than one quintile is equal to 1: take the highest quintile
	do i=1,nobi
		if (magquin(i,1) .eq. 1) then
			magquin(i,2:5)=0
		elseif (magquin(i,2) .eq. 1) then
			magquin(i,3:5)=0
		elseif (magquin(i,3) .eq. 1) then
			magquin(i,4:5)=0
		elseif (magquin(i,4) .eq. 1) then
			magquin(i,5)=0
		else 
			magquin(i,5)=1
		endif
		if (npquin(i,1) .eq. 1) then
			npquin(i,2:5)=0
		elseif (npquin(i,2) .eq. 1) then
			npquin(i,3:5)=0
		elseif (npquin(i,3) .eq. 1) then
			npquin(i,4:5)=0
		elseif (npquin(i,4) .eq. 1) then
			npquin(i,5)=0
		else 
			npquin(i,5)=1
		endif
		if (tvquin(i,1) .eq. 1) then
			tvquin(i,2:5)=0
		elseif (tvquin(i,2) .eq. 1) then
			tvquin(i,3:5)=0
		elseif (tvquin(i,3) .eq. 1) then
			tvquin(i,4:5)=0
		elseif (tvquin(i,4) .eq. 1) then
			tvquin(i,5)=0
		else 
			tvquin(i,5)=1
		endif
		if (othquin(i,1) .eq. 1) then
			othquin(i,2:5)=0
		elseif (othquin(i,2) .eq. 1) then
			othquin(i,3:5)=0
		elseif (othquin(i,3) .eq. 1) then
			othquin(i,4:5)=0
		elseif (othquin(i,4) .eq. 1) then
			othquin(i,5)=0
		else 
			othquin(i,5)=1
		endif
	enddo

	demo(1:nobi,7)=moredemo(1:nobi,2)*moredemo(1:nobi,4)					
	demo(1:nobi,5)=moredemo(1:nobi,17)+moredemo(1:nobi,18)					
	demo(1:nobi,6)=moredemo(1:nobi,20)										
	edu(1:nobi,3)=moredemo(1:nobi,8)+moredemo(1:nobi,9)+moredemo(1:nobi,10)	
	edu(1:nobi,5)=edu(1:nobi,1)*(moredemo(1:nobi,6)+moredemo(1:nobi,7))		
	cchar(1:nobi,1:7)=real(demo)
	cchar(1:nobi,8:11)=real(edu(1:nobi,2:5))
    cchar(:,12:13)=0.
    do i=1,nobi
		if (yr(i) .eq. 96) then
		    cchar(i,12)=1.
		elseif (yr(i) .eq. 97) then
		    cchar(i,13)=1.
		endif
    enddo

	nsim=0
	pcnew=0
	him=0
	do i=6701,nobi
		nsim=nsim+1
		if ((newpc(i) .eq. 1) .and. (pcchar(i,9) .eq. 1) .and. (venown(i,1) .ne. 0)) then
			pcnew(nsim)=1
		endif
		cchar_ad(nsim,1:12)=cchar(i,1:12)
		cchar_ad(nsim,12)=1
		cchar_ad(nsim,13)=cchar(i,8)+cchar(i,9)+cchar(i,10)		
		inc(nsim)=income(i)
		venpurch(nsim)=venown(i,1)			
		pciv(nsim,1)=pcchar(i,9)
		pciv(nsim,2)=pcchar(i,10)
		cchar_i(nsim,1)=cchar(i,1)
		cchar_i(nsim,2:6)=cchar(i,4:8)
		quintl(nsim,1:5)=quintile(nobi,6:10)		!quintl: np,mag,tv,rad quintile: mag,np,tv,rad
		quintl(nsim,6:10)=quintile(nobi,1:5)		!quintl: np,mag,tv,rad quintile: mag,np,tv,rad
		quintl(nsim,11:20)=quintile(nobi,11:20)		!quintl: np,mag,tv,rad quintile: mag,np,tv,rad
		do q=1,5
			if (npquin(i,q) .eq. 1) then 
				him(nsim,1)=q 
			endif
			if (magquin(i,q) .eq. 1) then 
				him(nsim,2)=q 
			endif
			if (tvquin(i,q) .eq. 1) then 
				him(nsim,3)=q 
			endif
			if (othquin(i,q) .eq. 1) then 
				him(nsim,4)=q 
			endif
		enddo
	enddo

	!vendor if own 1 pc
	do i=1,ncons
		v=venpurch(i)
		if (v .eq. 15) then
			venpurch(i)=14
		elseif (v .eq. 17) then
			venpurch(i)=15
		elseif (v .eq. 100) then
			venpurch(i)=16
		endif
	enddo
	ccharmean = sum(cchar_i,dim=1)
	ccharmean=ccharmean/nobi
	do i=1,ncons
		cchar_i(i,:)=cchar_i(i,:)-ccharmean
	enddo       

	close(60)
	close(70)

	return	
	end subroutine consget


	subroutine otherdata
	!	------------ gets cpi deflator and number of hhs info -------------
	!	variable order: year/quarter (for first 23 rows 95:1-00:3) then annual (95-00)
	!	deflator, number of households (in thousands)
	!	----------------------------------------------------------------------------

	implicit real*8 (a-h, o-z)
	integer, parameter :: rows=29
	integer i,j,hhs(rows),yyq(rows)
	real cpitemp(rows)
	common/deflator/cpi(rows)
	common/numhhs/hhs

	open(145,file='c:\michelle\pcad\programs\main\deflator.txt')
	do i=1,rows
		read(145,146)yyq(i),cpitemp(i),hhs(i)
	enddo
146 format (i8,1x,f11.8,1x,i13)
	cpi=dble(cpitemp)
	close(145)

	return 
	end subroutine otherdata

	subroutine ivget
	
	use numerical_libraries
	use linear_operators

	implicit real*8 (a-h, o-z)
	integer, parameter :: ns=9000,nqrt=12,nk=13,nnlk=4,npichar=4,nprod=2112,nm=4,nchar=6,nnhk=4,nadk=9,ncons=13400,nds=12,nups=nds*nm,	&
	nfirm=15,nlam=4,nr=3,nw=5,nfi=2,nrho=2,ntha=2+nlam+nfi+nrho+nadk+2,nsmallpsi=2,netad=nsmallpsi+nnhk,nth=npichar+1+nnlk+ntha,			&
	nparm=nth+netad,nallparm=nparm+nups,ntotparm=nallparm,nthl=nw+nk,niv=3*nth+nparm+nups,nmom=6*nprod+5*ncons
	integer i,f,qj,qr,m,v,r,vr,vj,k,kk,j,z,oldflag,intflag,nthn,numgrad,gflag,numline,lflag,hflag,numhalf,jbeg,jend,sumprodt,	&
	t,jt,nprod_t(nqrt),npt,np,testflag,ven(nprod)
	real*8 z_micro(ncons,nfirm,nth),z_xi(nprod,nth),z_w(nprod,nth),z_ad(nprod,nm,nparm),x(nprod,nk),w(nprod,nw),		&
	xnl(nprod,nnlk),adztemp(nprod,nparm),microz(ncons,nth),xiv(nprod,3),xx(nprod,10),pciv(ncons,2),adiv(nprod,2)
	real*8 aath(nth,nth),aaparm(nparm,nparm),inva(niv,niv),invaxi(nth,nth),invaad(nparm,nparm),invaw(nth,nth),		&
	aamicro(nth,nth),invamicro(nth,nth),aamedia(nups,nups),mediaz(ncons,nups),invamedia(nups,nups)
	real*8 xz(nk,nth),zxaxz(nk,nk),invbeta(nk,nk),wz(nw,nth),zwawz(nw,nw),inveta(nw,nw),zxxz(nk,nk),zwwz(nw,nw)
	real*8 intups(nm,13),ups(nm,nds),pi,sqrtpi,z_media(ncons,5,nups),zmediai(nm,5,nds),consdemups(ncons,nm),cchar_ad(ncons,13),	&
	thresh(4,nm),threshm(4),ddsum,dsum1,dsum2,dsum3,dsum4,F1,F2,F3,F4,ff1,ff2,ff3,ff4,q1,q2,q3,q4,q5,D_id
	common/evals/numgrad,gflag,numline,lflag,hflag,numhalf
	common/instr/z_xi,z_w
	common/adinstr/z_ad
	common/microinstr/z_micro
	common/mediainstr/z_media
	common/weightmat/inva
	common/weightmatparts/invaxi,invaw,invaad,invamicro
	common/weightmatmedia/invamedia
	common/vars/x,xnl,w
	common/thetalinear/xz,wz,invbeta,inveta
	common/tobs/nprod_t					
	common/vendor/ven	
	common/xinstru/xiv
	common/consints/pciv
	common/mediac/thresh				
	common/conchar/cchar_ad				        
	common/simdemoups/consdemups

	open(160, file='c:\michelle\pcad\programs\main\xiinstr1.txt')
	open(165, file='c:\michelle\pcad\programs\main\winstr1.txt')
	open(175, file='c:\michelle\pcad\programs\main\xiinstr2.txt')
	open(180, file='c:\michelle\pcad\programs\main\winstr2.txt')
	open(190, file='c:\michelle\pcad\programs\main\xiinstr3.txt')
	open(195, file='c:\michelle\pcad\programs\main\winstr3.txt')
	open(205, file='c:\michelle\pcad\programs\main\xiinstr4.txt')
	open(210, file='c:\michelle\pcad\programs\main\winstr4.txt')

	do t=1,nqrt
		sumprodt=0
		npt=nprod_t(t)
		if (t .ge. 2) then
			do jt=1,t-1
				sumprodt=sumprodt+nprod_t(jt)
			enddo
		endif
		jbeg=sumprodt+1
		jend=sumprodt+npt
		np=nprod_t(t)
		if (t .le. 4) then
			do j=jbeg,jend
				read(160,250)(z_xi(j,v),v=1,nth)
				read(165,250)(z_w(j,v),v=1,nth)
			enddo
		elseif (t .le. 8) then
			do j=jbeg,jend
				read(175,250)(z_xi(j,v),v=1,nth)
			enddo
			do j=jbeg,jend
				read(180,250)(z_w(j,v),v=1,nth)
			enddo
		elseif (t .le. 10) then
			do j=jbeg,jend
				read(190,250)(z_xi(j,v),v=1,nth)
			enddo
			do j=jbeg,jend
				read(195,250)(z_w(j,v),v=1,nth)
			enddo
		else
			do j=jbeg,jend
				read(205,250)(z_xi(j,v),v=1,nth)
			enddo
			do j=jbeg,jend
				read(210,250)(z_w(j,v),v=1,nth)
			enddo
		endif	
	enddo

	!to calculate weight matrix, calculate each block diagonal matrix element separately
	inva=0.
	aath=0.
	aath=matmul(transpose(z_xi),z_xi)
	invaxi=0.
	call dlinrg(nth,aath,nth,invaxi,nth)
	inva(1:nth,1:nth)=invaxi
	aath=0.
	aath=matmul(transpose(z_w),z_w)	
	invaw=0.
	call dlinrg(nth,aath,nth,invaw,nth)
	inva(nth+1:2*nth,nth+1:2*nth)=invaw
	xz=matmul(transpose(x),z_xi)
	zxaxz=matmul(matmul(xz,invaxi),transpose(xz))
	invbeta=0.
	call dlinrg(nk,zxaxz,nk,invbeta,nk)
	wz=matmul(transpose(w),z_w)
	zwawz=matmul(matmul(wz,invaw),transpose(wz))
	inveta=0.
	call dlinrg(nw,zwawz,nw,inveta,nw)

	close(160)
	close(165)
	close(175)
	close(180)
	close(190)
	close(195)
	close(205)
	close(210)

	open(80, file='c:\michelle\pcad\programs\main\microinstr.txt')
	do i=1,ncons
		do f=1,nfirm
			do v=1,nth-2
				read(80,265)z_micro(i,f,v)
			enddo
		enddo
	enddo
	close(80)
	do f=1,nfirm	
		z_micro(:,f,nth-1)=pciv(:,1)
		z_micro(:,f,nth)=pciv(:,2)
	enddo

250	format(14(1x,d20.7)) 
251	format(1x,f20.7)
260	format(20(1x,d20.7)) 
265	format(1x,d20.7) 

	aamicro=0.
	do f=1,nfirm
		microz(:,1:nth)=z_micro(:,f,1:nth)
		aamicro=aamicro+matmul(transpose(microz),microz)
	enddo
	call dlinrg(nth,aamicro,nth,invamicro,nth)
	inva(2*nth+nparm+1:3*nth+nparm,2*nth+nparm+1:3*nth+nparm)=invamicro

	open(170, file='c:\michelle\pcad\programs\main\adinstr4.txt')
	open(185, file='c:\michelle\pcad\programs\main\adinstr8.txt')
	open(200, file='c:\michelle\pcad\programs\main\adinstr10.txt')
	open(215, file='c:\michelle\pcad\programs\main\adinstr12.txt')

	tloop: do t=1,nqrt
		sumprodt=0
		npt=nprod_t(t)
		if (t .ge. 2) then
			do jt=1,t-1
				sumprodt=sumprodt+nprod_t(jt)
			enddo
		endif
		jbeg=sumprodt+1
		jend=sumprodt+npt
		np=nprod_t(t)
		if (t .le. 4) then
			do j=jbeg,jend
				do m=1,nm
					read(170,260)(z_ad(j,m,v),v=1,nparm-2)
				enddo
			enddo
		elseif (t .le. 8) then
			do j=jbeg,jend
				do m=1,nm
					read(185,260)(z_ad(j,m,v),v=1,nparm-2)
				enddo
			enddo
		elseif (t .le. 10) then
			do j=jbeg,jend
				do m=1,nm
					read(200,260)(z_ad(j,m,v),v=1,nparm-2)
				enddo
			enddo
		else
			do j=jbeg,jend
				do m=1,nm
					read(215,260)(z_ad(j,m,v),v=1,nparm-2)
				enddo
			enddo
		endif	
	enddo tloop
	close(170)
	close(185)
	close(200)
	close(215)


	z_ad(:,:,nth+1:nparm)=z_ad(:,:,nth-1:nparm-2)
	z_ad(:,1,nth-1)=z_xi(:,12)
	z_ad(:,2,nth-1)=z_xi(:,18)
	z_ad(:,3,nth-1)=z_xi(:,19)
	z_ad(:,4,nth-1)=z_xi(:,20)								
	z_ad(:,1,nth)=z_xi(:,22)
	z_ad(:,2,nth)=z_xi(:,28)
	z_ad(:,3,nth)=z_xi(:,29)
	z_ad(:,4,nth)=z_xi(:,30)								
	
	aaparm=0.
	do m=1,nm
		adztemp=z_ad(:,m,:)
		aaparm=aaparm+matmul(transpose(adztemp),adztemp)
	enddo
	invaad=0.
	call dlinrg(nparm,aaparm,nparm,invaad,nparm)
	inva(2*nth+1:2*nth+nparm,2*nth+1:2*nth+nparm)=invaad
			
	open(80, file='c:\michelle\pcad\programs\main\upsilon.txt')	      	      
	do m=1,nm
		read(80,180)(intups(m,i),i=1,13)		
	enddo
	close(80)
180	format(d15.7,12(1x,d15.7)) 
	intups(:,12)=-1.						
	ups(1,:)=intups(2,1:nds)				
	ups(2,:)=intups(1,1:nds)		
	ups(3,:)=intups(3,1:nds)		
	ups(4,:)=intups(4,1:nds)		

	pi=acos(-1.)
	sqrtpi=1./(sqrt(2*pi))
	consdemups=matmul(cchar_ad(:,1:12),transpose(ups))
	z_media=0.
		iloop: do i=1,ncons
		zmediai=0.
		mloop: do m=1,nm
			threshm=thresh(:,m)
			ddsum=consdemups(i,m)
			dsum1=threshm(1)-ddsum
			dsum2=threshm(2)-ddsum
			dsum3=threshm(3)-ddsum
			dsum4=threshm(4)-ddsum
			F1=dnordf(dsum1)
			F2=dnordf(dsum2)
			F3=dnordf(dsum3)
			F4=dnordf(dsum4)
			ff1=sqrtpi*exp(-dsum1*dsum1/2.0)
			ff2=sqrtpi*exp(-dsum2*dsum2/2.0)
			ff3=sqrtpi*exp(-dsum3*dsum3/2.0)
			ff4=sqrtpi*exp(-dsum4*dsum4/2.0)
			q1=(ff1)/(F1-1)
			q2=(ff1-ff2)/(F2-F1)
			q3=(ff2-ff3)/(F3-F2)
			q4=(ff3-ff4)/(F4-F3)
			q5=(ff4)/-F4
			do d=1,nds
				D_id=cchar_ad(i,d)
				zmediai(m,1,d)=q1*D_id
				zmediai(m,2,d)=q2*D_id
				zmediai(m,3,d)=q3*D_id
				zmediai(m,4,d)=q4*D_id
				zmediai(m,5,d)=q5*D_id
			enddo
		enddo mloop
		z_media(i,:,1:nds)=zmediai(1,:,:)
		z_media(i,:,nds+1:2*nds)=zmediai(2,:,:)
		z_media(i,:,2*nds+1:3*nds)=zmediai(3,:,:)
		z_media(i,:,3*nds+1:nups)=zmediai(4,:,:)
	enddo iloop

	aamedia=0.
	do q=1,5
		mediaz=z_media(:,q,:)
		aamedia=aamedia+matmul(transpose(mediaz),mediaz)
	enddo
	invamedia=0.
	call dlinrg(nups,aamedia,nups,invamedia,nups)
	inva(3*nth+nparm+1:niv,3*nth+nparm+1:niv)=invamedia

	return	
	end subroutine ivget

